#include <ctype.h>
#include <string.h>
#include <stdio.h>

#include "32base.h"

uShort base32char( uChar ch )
{
  return uShort( ch>'9' ? ch-'A'+10 : ch-'0' );
}

uChar char32base( uShort ind )
{
  return uChar( ind + ( ind>9 ? 'a'-10 : '0' ) );
}



int val32base( char *s, int how, uShort& val )
{
  val = 0;

  while( how  )
  {
    char ch( (char)toupper(*s) );

    if( (ch>='0' && ch<='9') || (ch>='A' && ch<='A'+21) )
      val = uShort( int(val)*32 + base32char( ch ) );
    else
      return 1;
      
    how--;
    s++;
  }

  return 0;
}

int split32base( char *name, uShort& zone, uShort& net,
		 uShort& node, uShort& point )
{
  zone = net = node = point = 0;

  if( name==NULL )
    return 1;

  register int rc = strlen( name );

  if( (rc==12 || rc==11) && name[8]=='.' )
    rc = val32base( name, 2, zone )      ||
         val32base( name+2, 3, net )     ||
         val32base( name+5, 3, node )    ||
         val32base( name+9, 2, point );
  else
    rc = 1;

  return !rc;
}

void to32base( uShort val, int how, char *to )
{

  while( how )
  {
    to[ how-1 ] = char( char32base( uShort(val%32) ) );
    val /= 32;
    how--;
  }

}

int val16base( register char *s, unsigned short& val )
{
  val = 0;

  while( *s )
  {
    char ch( (char)toupper(*s) );

    if( (ch>='0' && ch<='9') || (ch>='A' && ch<='F') )
      val = uShort( val*16 + base32char( ch ) );
    else
      return 1;
      
    s++;
  }

  return 0;
}

int split16base( char *nameIni, uShort& net, uShort& node )
{
  net = node = 0;

  if( nameIni==NULL )
    return 0;

  char nameNet[5],
       nameNode[5];

  memcpy( nameNet, nameIni, 4 );
  memcpy( nameNode, nameIni+4, 4 );
  nameNet[4]=0;
  nameNode[4]=0;
  strupr( nameNet );
  strupr( nameNode );

  register int rc(
	  ( val16base( nameNet, net ) )                   ||
	  ( val16base( nameNode, node ) ) );

  return !rc;
}
