#include "boxitem.h"

BoxItem::BoxItem( char *nm, Priority p, unsigned long crea ) :
  name( newStr(nm) ),
  prio( p ),
  created( crea )
{
}

BoxItem::~BoxItem()
{
  delete name;
}

char *BoxItem::nameOfClass() const
{
  return "BoxItem";
}

int BoxItem::equal( const BaseObject &t ) const
{
  return !stricmp( name, (*(const BoxItem *)&t).name );
}
    
void BoxItem::print( ostream& ) const
{
}

int BoxItem::less( const BoxItem &cmp ) const
{
  if( prio < cmp.prio )
    return 1;
  else if( prio > cmp.prio )
    return 0;

  if( created < cmp.created )
    return 1;

  return 0;
}

BoxItemList::BoxItemList() :
  Collection( 10, 10, SemaphoreModeNoNeed )
{
}
  
BoxItem* BoxItemList::Find( BoxItem& item, LockMode lock ) const
{
  return (BoxItem*)Collection::Find( item, lock );
}
    
BoxItem& BoxItemList::operator [] ( const int pos ) const
{
  return *(BoxItem *)&(Collection::operator[]( pos ));
}

void BoxItemList::sort()
{
  int i;

  for( i=1; i<used; i++ )
  {
    BoxItem *x = (BoxItem *)list[i];
    int j = i-1;

    while( j!=-1 && x->less( *(BoxItem*)(list[j]) ) )
    {
      list[j+1] = list[j];
      --j;
    }

    list[j+1] = x;
  }
}

BoxItemIterator::BoxItemIterator( BoxItemList& ini ) : 
  CollectionIterator( *(Collection *)&ini )
{
}
  
BoxItem& BoxItemIterator::operator () () const
{
  return *(BoxItem *)&(CollectionIterator::operator()());
}
