VERSION = 718.a14
Signature = "John Gladkih" $(VERSION) "The Brake!(tm) Mailer,

CC = icc /Q /Gm /Ti /Tx /DBUILD_VERSION=\"$(VERSION)\" /WAll /Wppt- /Wppc- /Wcpy- /Wgnr- /Wvft-
# /Fb*
# /Wcnv-
# /o /oc
# /FiBrake.Pre /SiBrake.Pre
# /O /Oi 

LINK = ilink /nofree /nologo /pmt:vio /Ali:4 /NODef 
#/OPTf 

BUILD_LOG = >>"!build-e.log" 2>&1

!ifdef DEBUG
DEBUGINFO = /DEbug /BRowse
!endif

# =========================== RULEzzz

.cpp.obj:
	@echo ******************* Compile: $< $(BUILD_LOG)
	$(CC) /c $< $(BUILD_LOG)

.c.obj:
	@echo ******************* Compile: $< $(BUILD_LOG)
	$(CC) /c $< $(BUILD_LOG)

# =========================== LIST

obj01 = 32base.obj addinqu.obj answer.obj beep.obj binlog.obj brake.obj bsyproc.obj
obj02 = buffer.obj calls.obj cfgparse.obj cfgstack.obj clipio.obj compiler.obj config.obj
obj03 = cost.obj crc.obj cursor.obj debug.obj dialog.obj domain.obj direct.obj
obj04 = emsi.obj enable.obj except.obj execute.obj fidoaddr.obj filetype.obj
obj05 = flags.obj freq.obj getopt.obj gettid.obj help.obj inifile.obj
obj06 = init.obj key.obj keyf.obj keycddll.obj log.obj login.obj mailer.obj misc.obj
obj07 = modem.obj modemdmp.obj modemos.obj nodelist.obj vio.obj viowrt.obj
obj08 = os2msg.obj pair.obj process.obj qentry.obj queue.obj recover.obj
obj09 = reset.obj rexx.obj rexxhook.obj sched.obj schedprc.obj semaphor.obj
obj10 = session.obj shmem.obj splitter.obj terminal.obj timer.obj translat.obj
obj11 = window.obj worktime.obj zdialog.obj zmisc.obj zreceive.obj zsend.obj
obj12 = hdialog.obj hydra.obj ea.obj boxitem.obj fax.obj sleeper.obj heap.obj
obj13 = rcvdlist.obj timeout.obj nolog.obj winhand.obj globlvar.obj class.obj
obj14 = regexp.obj

#xmsend.obj

objls1 = $(obj01) $(obj02) $(obj03) $(obj04) $(obj05) $(obj06) $(obj07)
objls2 = $(obj08) $(obj09) $(obj10) $(obj11) $(obj12) $(obj13) $(obj14)

objlist = $(objls1) $(objls2)

# =========================== Hs

classh = class.h log.h sleeper.h
boxitemh =  $(classh) boxitem.h
globlvarh =  $(classh) globlvar.h
worktimeh =  $(classh) worktime.h
inbufh =  $(classh) inbuff.h
rcvdlisth =  $(classh) rcvdlist.h
cfgparseh =  $(classh) cfgparse.h newstr.h
timeouth = timeout.h $(classh)
semaphorh = semaphor.h $(classh) newstr.h
windowh = window.h zforms.h $(semaphorh)
winhandh =  $(classh) winhand.h $(windowh)
modemh = buffer.h $(windowh) $(classh) timer.h
translath = translat.h $(classh)
domainh = domain.h $(classh) newstr.h
fidoaddrh = fidoaddr.h $(classh) $(worktimeh) $(nodelisth) $(domainh)
schedh = sched.h $(fidoaddrh)
pairh = pair.h $(schedh) emsi.h $(classh)

misch1 = misc.h $(fidoaddrh) cursor.h $(windowh) $(modemh) $(worktimeh) $(pairh)
misch2 = log.h $(semaphorh) $(domainh) $(schedh) $(classh) newstr.h
misch = $(misch1) $(misch2) ea.h sleeper.h

enableh = enable.h regexp.h $(misch) $(classh)
nodelisth = nodelist.h buffer.h $(semaphorh)

queueh1 = queue.h $(classh) $(fidoaddrh) $(misch)
queueh2 = filetype.h $(semaphorh) shmem.h $(enableh)
queueh = $(queueh1) $(queueh2)

sessionh = session.h $(queueh)
executeh = execute.h $(schedh)
rexxh = rexx.h $(fidoaddrh) $(schedh)
zmodemh = zmodem.h rcvdlist.h
hydrah = hydra.h $(timeouth) $(windowh) $(rcvdlisth) $(zmodemh) $(classh)
rexxhookh = rexxhook.h $(classh)
callsh = calls.h $(classh)
configh = config.h buffer.h $(misch)
costh = cost.h $(queueh)
processh = process.h regexp.h $(fidoaddrh) $(schedh) $(classh) $(rcvdlisth)
zinterh = zinter.h $(windowh) $(zmodemh) recover.h crc.h ascii.h
hdialogh = hdialog.h filetype.h
addinquh = addinqu.h $(classh) $(queueh) filetype.h
nologh = $(classh) newstr.h
faxh = fax.h ascii.h
freqh = freq.h regexp.h $(classh) $(sessionh)
xmodemh = xmodem.h timer.h

# =========================== EXEs

All: Clean BrakePm.Dll brake.exe makemap.cmd braketrc.h braketrc.def
  makemap.cmd braked.map
  @echo ******************* Compile: braketrc.cpp $(BUILD_LOG)
  $(CC) /Tx- /c /O /Oi braketrc.cpp $(BUILD_LOG)
  @echo +++++++++++++++++++ Linking: braketrc $(BUILD_LOG)
  $(LINK) @<<tracer.lrf $(BUILD_LOG)
braketrc.obj,braketrc.Dll,null,os2386.lib,braketrc.def
<<
  copy \ibmcpp\dll\dde4mth.dll dde4mth.dll >nul 2>&1
  copy locale\english.lcl english.lcl >nul 2>&1
  copy locale\russian.lcl russian.lcl >nul 2>&1
  dllrname english.lcl russian.lcl dde4mth.dll dde4mth=BrakeLc >nul
  msgbind Brake.Bnd >nul
  mk.cmd ICON Brake.Exe
  stub\level Brake.Exe $(Signature) Main executable"
  mk.cmd ICON Brake.Dll
  stub\level Brake.Dll $(Signature) Master library"
  mk.cmd ICON BrakeTrc.Dll
  stub\level BrakeTrc.dll  $(Signature) Back tracer subsystem library"
  mk.cmd ICON BrakePm.Dll
  stub\level BrakePm.dll  $(Signature) Presentation Manager subsystem library"
  mk.cmd ICON Brakelc.Dll
  stub\level Brakelc.dll  $(Signature) Locale support library"
  mk.cmd ICON english.dll
  stub\level english.dll  $(Signature) English language library"
  mk.cmd ICON russian.Dll
  stub\level russian.dll  $(Signature) Russian language library"
  mk.cmd ICON BrakeLng.Dll
  stub\level BrakeLng.Dll $(Signature) Default (english) language library"
  mk.cmd ICON english.lcl
  stub\level english.lcl  $(Signature) English locale"
  mk.cmd ICON russian.lcl
  stub\level russian.lcl  $(Signature) Russian locale"
  cd addin
  nmake /nologo
  cd ..

Clean:
  -del /f russian.lcl >nul 2>&1
  -del /f english.lcl >nul 2>&1
  -del /f russian.dll >nul 2>&1
  -del /f english.dll >nul 2>&1
  -del /f brakelng.dll >nul 2>&1
  -del /f brakelc.dll >nul 2>&1
  -del /f brakepm.dll >nul 2>&1
  -del /f brake.dll   >nul 2>&1
  -del /f brake.exe   >nul 2>&1
  -del /f brake-?.def >nul 2>&1
  -del /f language    >nul 2>&1
  -del /f langimp.def >nul 2>&1
  -del /f langexp.def >nul 2>&1

brake.exe: bmain.obj brake-e.def brake.dll brake.rc brakepm.h
  @echo +++++++++++++++++++ Linking: brake.exe $(BUILD_LOG)
  $(LINK) $(DEBUGINFO) /base:65536 @<<brakeexe.lrf $(BUILD_LOG)
 bmain.obj,Brake.Exe,BrakeE.Map,cppom30.lib os2386.lib,brake-e.def
<<
  rc brake.rc $(BUILD_LOG)
  del brake.res >nul 2>&1

BrakeDef = Brake-D.Def
BrakeExe = Brake.Dll
BrakeMap = BrakeD.Map
objs = $(objlist)
switch = /dll
SBS = sbsstub.obj
base = 

!ifdef LineNumbers
switch = $(switch) /lin
!endif

$(BrakeExe): $(objs) $(BrakeDef) zforms32.lib brakelng.dll
  @echo +++++++++++++++++++ Linking: $(BrakeExe) $(BUILD_LOG)
  $(LINK) $(switch) $(DEBUGINFO) $(base) /map @<<brakedll.lrf $(BUILD_LOG)
 $(objs: = +^
) $(SBS)
$(BrakeExe)
$(BrakeMap)
zforms32.lib cppom30.lib rexx.lib os2386.lib
$(BrakeDef)
<<
# _doscall.lib

# =========================== LIBs

brakelng.dll: english.dll russian.dll
        copy english.dll BrakeLng.Dll >nul 2>&1

russian.dll: brake-l.def russian.obj
        @echo +++++++++++++++++++ Linking: russian.dll $(BUILD_LOG)
        $(LINK) @<<russian.lrf $(BUILD_LOG)
russian.obj,Russian.Dll,nul,,brake-l.def
<<

english.dll: brake-l.def english.obj
        @echo +++++++++++++++++++ Linking: english.dll $(BUILD_LOG)
        $(LINK) @<<english.lrf $(BUILD_LOG)
english.obj,English.Dll,nul,,brake-l.def
<<

russian.obj: russian.cpp language.h brake.mak
   @echo ******************* Compile: russian.cpp $(BUILD_LOG)
   $(CC) /Tx- /c /O /Oi russian.cpp $(BUILD_LOG)

english.obj: english.cpp language.h brake.mak
   @echo ******************* Compile: english.cpp $(BUILD_LOG)
   $(CC) /Tx- /c /O /Oi english.cpp $(BUILD_LOG)

brakepm.dll: brakepm.def brakepm.obj
        @echo +++++++++++++++++++ Linking: brakepm.dll $(BUILD_LOG)
        $(LINK) $(DEBUGINFO) @<<brakepm.lrf $(BUILD_LOG)
sbsstub.obj brakepm.obj,brakepm.Dll,,cppom30.lib os2386.lib,brakepm.def
<<

brakepm.obj: brakepm.cpp brakepm.h
   @echo ******************* Compile: brakepm.cpp $(BUILD_LOG)
   $(CC) /Tx- /c /O /Oi brakepm.cpp $(BUILD_LOG)

# =========================== DEFs

brake-e.def: brakeexe.def
  copy brakeexe.def brake-e.def >nul 2>&1

brake-d.def: brakedll.def language
  copy brakedll.def+langimp.def brake-d.def >nul 2>&1

brake-l.def: brakelng.def language
  copy brakelng.def+langexp.def brake-l.def >nul 2>&1

language: language.h brake.mak
	icc /Q /DLANGUAGE_NEED_EXPORT /P Language.H $(BUILD_LOG)
        mk.cmd LANGUAGE
	echo language>language

# =========================== OBJs

class.obj: class.cpp $(classh)

ea.obj: ea.cpp $(misch) language.h

start.obj: start.c

direct.obj: direct.cpp direct.h

except.obj: except.cpp key.h

memdbgasm.obj: memdbgasm.asm

gettid.obj: gettid.cpp

cfgparse.obj: cfgparse.cpp $(misch) buffer.h $(configh) $(classh) \
	      language.h $(cfgparseh)

compiler.obj: compiler.cpp $(misch) language.h $(nodelisth) \
              $(queueh) except.h crc.h direct.h

debug.obj: debug.cpp $(rexxh) $(misch) $(schedh) $(queueh) $(translath) \
           $(zmodemh) $(zinterh) $(processh) $(freqh) $(callsh) $(enableh) \
           $(configh) $(rexxhookh) language.h $(timeouth) $(hydrah) \
           $(addinquh) $(nologh) $(faxh) heap.h

rexx.obj: rexx.cpp $(rexxh) language.h $(misch) buffer.h key.h $(pairh) \
          timer.h $(queueh) $(executeh) $(winhandh) $(sessionh) \
          $(faxh) crc.h except.h $(zinterh) $(callsh) keycd.h $(processh) \
          $(rexxhookh) $(nologh) $(addinquh) $(freqh) $(globlvarh) heap.h

rexxhook.obj: rexxhook.cpp language.h $(misch) $(rexxh) $(rexxhookh)

clipio.obj: clipio.cpp language.h $(misch) buffer.h except.h

beep.obj: beep.cpp language.h $(misch) except.h

domain.obj: domain.cpp $(domainh)

binlog.obj: binlog.cpp language.h $(misch) except.h

bsyproc.obj: bsyproc.cpp language.h $(misch) 32base.h \
             except.h direct.h

reset.obj: reset.cpp language.h $(misch) 32base.h except.h direct.h

cfgstack.obj: cfgstack.cpp language.h $(configh) $(misch)

enable.obj: enable.cpp $(enableh)

zsend.obj: zsend.cpp language.h $(misch) timer.h \
           $(zinterh) zdialog.h direct.h $(sessionh)

zreceive.obj: zreceive.cpp language.h $(misch) timer.h \
              filetype.h $(sessionh) $(processh) zdialog.h $(zinterh)

zmisc.obj: zmisc.cpp language.h $(misch) timer.h filetype.h \
           key.h zdialog.h $(zinterh) newstr.h except.h direct.h \
           $(timeouth) buffer.h

zdialog.obj: zdialog.cpp language.h $(misch) $(zinterh) zdialog.h \
             filetype.h $(sessionh) $(queueh) except.h direct.h

WORKTIME.obj: WORKTIME.CPP $(misch)

translat.obj: translat.cpp $(translath) $(misch)

timer.obj: timer.cpp timer.h $(misch)

terminal.obj: terminal.cpp language.h $(misch) $(fidoaddrh)  \
              $(nodelisth) timer.h $(pairh) buffer.h key.h $(zmodemh) zdialog.h \
              $(executeh) $(rexxh) $(rexxhookh) $(hydrah) except.h dinamic.h

splitter.obj: splitter.CPP language.h $(fidoaddrh) $(misch) filetype.h \
              32base.h except.h direct.h $(zmodemh)

SESSION.obj: SESSION.CPP language.h $(sessionh) $(misch) \
             buffer.h $(processh) $(freqh) filetype.h $(rexxhookh) \
             $(rexxh) $(schedh) $(zmodemh) $(zinterh) zdialog.h $(costh) \
             except.h direct.h $(hydrah) $(boxitemh) $(faxh)

boxitem.obj: boxitem.cpp $(boxitemh)

cost.obj: cost.cpp $(costh) $(misch) language.h $(queueh)

semaphor.obj: semaphor.cpp language.h $(misch) $(semaphorh) $(nodelisth) $(queueh)

sched.obj: sched.cpp language.h $(misch) $(schedh) $(configh) $(rexxh) \
	   timer.h $(sessionh) $(pairh) $(fidoaddrh) $(queueh) $(executeh) \
           except.h $(freqh)

recover.obj: recover.cpp language.h $(misch) $(zinterh) zdialog.h \
             filetype.h $(sessionh) $(freqh) buffer.h direct.h

mailer.obj: mailer.cpp language.h $(misch) $(queueh) $(translath) \
            32base.h key.h timer.h $(fidoaddrh) $(pairh) $(schedh) $(executeh) \
            $(sessionh) $(configh) $(rexxh) $(rexxhookh) except.h dinamic.h

queue.obj: queue.cpp language.h $(misch) $(queueh) $(translath) \
           32base.h key.h $(fidoaddrh) $(schedh) $(executeh) \
           $(sessionh) $(rexxhookh) direct.h dinamic.h $(addinquh) heap.h

QENTRY.obj: QENTRY.CPP language.h $(misch) $(queueh) \
            $(translath) $(enableh) $(rexxhookh) $(costh) direct.h

process.obj: process.cpp language.h $(misch) $(processh) filetype.h \
             $(executeh) $(rexxh) $(sessionh)

PAIR.obj: PAIR.CPP $(misch) $(pairh) $(schedh)

os2msg.obj: os2msg.cpp language.h $(misch)

nodelist.obj: nodelist.cpp language.h $(nodelisth) $(misch) $(semaphorh)

modemos.obj: modemos.cpp language.h $(misch) timer.h buffer.h \
             key.h except.h newstr.h $(inbufh) $(hydrah)

modemdmp.obj: modemdmp.cpp $(misch)

modem.obj: modem.cpp language.h $(misch) timer.h buffer.h \
           key.h $(callsh) $(hydrah) $(rexxhookh) $(faxh)

misc.obj: misc.cpp language.h $(misch) timer.h $(queueh) \
          $(nodelisth) $(translath) key.h $(zinterh) $(hdialogh) heap.h

log.obj: log.CPP language.h $(misch) timer.h $(queueh) \
         $(nodelisth) $(translath) key.h $(rexxhookh)

init.obj: init.cpp $(rexxh) language.h register.h $(misch) $(translath) \
          $(queueh) $(nodelisth) $(zmodemh) $(zinterh) $(processh) \
          $(schedh) $(enableh) $(configh) $(callsh) $(rexxhookh) key.h crc.h \
	  $(timeouth) $(hydrah) dinamic.h $(addinquh) $(nologh) $(faxh) \
          $(freqh) vio.h heap.h brake.mak

inifile.obj: inifile.cpp language.h $(misch) dinamic.h

help.obj: help.cpp language.h $(misch) key.h timer.h

FIDOADDR.obj: FIDOADDR.CPP language.h $(fidoaddrh) $(queueh) $(misch) \
              $(translath) 32base.h $(callsh) $(rexxhookh) direct.h \
              $(zmodemh) ea.h

execute.obj: execute.cpp language.h $(misch) $(sessionh) $(executeh) \
             $(processh) $(schedh) key.h

EMSI.obj: EMSI.CPP language.h emsi.h $(pairh) timer.h crc.h $(misch) \
          key.h $(sessionh) buffer.h $(rexxhookh)

dialog.obj: dialog.cpp language.h $(misch) $(fidoaddrh) $(queueh)

crc.obj: crc.cpp crc.h

config.obj: config.cpp language.h $(misch) $(processh) buffer.H \
           $(fidoaddrh) $(nodelisth) $(translath) $(pairh) $(zmodemh) \
           $(zinterh) $(freqh) $(callsh) $(enableh) $(configh) $(rexxhookh) \
           $(timeouth) $(hydrah) $(addinquh) $(nologh) $(faxh)

buffer.obj: buffer.cpp buffer.h $(misch)

BRAKE.obj: BRAKE.CPP language.h $(configh) $(misch) timer.h buffer.h \
           $(fidoaddrh) $(queueh) $(nodelisth) $(processh) $(schedh) \
           $(zinterh) $(rexxhookh) key.h except.h heap.h

answer.obj: answer.CPP $(misch) $(freqh) $(sessionh)

key.obj: key.cpp key.h $(misch) language.h except.h vio.h

keyf.obj: keyf.c key.h

window.obj: window.cpp $(windowh) $(misch) $(semaphorh) language.h

cursor.obj: cursor.cpp cursor.h

32base.obj: 32base.cpp 32base.h

keycddll.obj: keycddll.cpp keycd.h

getopt.obj: getopt.cpp getopt.h

filetype.obj: filetype.cpp language.h filetype.h

flags.obj: flags.cpp language.h $(misch) except.h $(semaphorh)

schedprc.obj: schedprc.cpp language.h $(misch) $(schedh) $(queueh) \
              $(sessionh) except.h $(semaphorh)

login.obj: login.cpp $(misch) language.h timer.h except.h

bmain.obj: bmain.cpp

shmem.obj: shmem.cpp $(misch) language.h shmem.h

hdialog.obj: hdialog.cpp except.h language.h $(hdialogh) $(misch) $(zinterh) \
             hydraint.h filetype.h $(sessionh) $(nologh)

hydra.obj: hydra.cpp $(hydrah) hydraint.h $(hdialogh) language.h $(zmodemh) \
           $(zinterh) $(misch) timer.h crc.h recover.h direct.h \
           direct.h $(processh) $(sessionh) except.h key.h

vio.obj: vio.cpp vio.h

viowrt.obj: viowrt.c vio.h

addinqu.obj: addinqu.cpp $(addinquh) language.h $(misch) newstr.h

fax.obj: fax.cpp $(faxh) language.h timer.h $(misch) except.h

freq.obj: freq.cpp $(freqh) language.h $(misch) buffer.h \
          direct.h $(sessionh) except.h $(rexxhookh) newstr.h

calls.obj: calls.cpp $(callsh) newstr.h

sleeper.obj: sleeper.cpp sleeper.h language.h log.h

heap.obj: heap.cpp heap.h

rcvdlist.obj: rcvdlist.cpp $(rcvdlisth)

timeout.obj: timeout.cpp $(timeouth)

nolog.obj: nolog.cpp $(nologh) newstr.h

winhand.obj: winhand.cpp $(winhandh)

globlvar.obj: globlvar.cpp $(globlvarh) newstr.h

xmsend.obj: xmsend.cpp language.h $(misch) $(xmodemh)

regexp.obj: regexp.cpp regexp.h
