#ifndef __CALLS_H

#define __CALLS_H

#include "class.h"

class Calls : public BaseObject
{
private:
  char *flag,
       *pref;
       
  int equal( const BaseObject &t ) const;
  void print( ostream& s ) const;
  char *nameOfClass() const;

public:

  Calls( char *f, char *p );
  ~Calls();

  char *getFlag() const { return flag; }
  char *getPref() const { return pref; }
};

class CallsList : public Collection
{
public:
  CallsList();
  
  Calls* Find( Calls& item, LockMode lock=LockModeNeed ) const;
  Calls& operator [] ( const int pos ) const;
};

class CallsIterator : public CollectionIterator
{
public:
  CallsIterator( CallsList& ini );
  
  Calls& operator () () const;
};

extern CallsList *preffixList;
extern CallsList *suffixList;
extern CallsList *arqList;
extern CallsList *halfDuplexList;

#endif
