#define INCL_DOSQUEUES
#define INCL_DOSPROCESS
#define INCL_DOSFILEMGR
#define INCL_DOSEXCEPTIONS
#include <os2.h>

#include <process.h>
#include <string.h>
#include <stdio.h>

#include "except.h"

#include "language.h"

#include "misc.h"
#include "buffer.h"

static volatile char needAbort=0;
static volatile char needRead=1;

void _Optlink ClipConsoleServer( void *q )
{
  registerExceptionHandler

  HFILE handle( (HFILE)q );
  unsigned char buf[ 4096+1 ];
  char clipStr( 1 );
  int nAbort( 0 );

  Buffer bufAdd;

  while( 1 )
  {
    ULONG readed( 0 );

    if( clipStr )
    {
      clipStr = 0;
      bufAdd.putInto( 0 );

      if( strlen(bufAdd.str) )
	log( "CLIP: %s", bufAdd.str );

      bufAdd.reset();
    }

    APIRET rc=5;

    if( needRead )
      rc = DosRead( handle, buf, sizeof(buf)-1, &readed );
    else
      sleep( 1000 );

    if( readed && !rc )
      for( ULONG i=0; i<readed; i++ )
      {
        if( buf[i]==0xff && needAbort )
        {
          if( ++nAbort==10 )
          {
            deRegisterExceptionHandler
            return;
          }

          continue;
        }
        else
          nAbort = 0;

	if( clipStr )
        {
          clipStr = 0;
          bufAdd.putInto( 0 );

          if( strlen(bufAdd.str) )
            log( "CLIP: %s", bufAdd.str );

          bufAdd.reset();
        }

        if( buf[i]=='\r' && buf[i+1]=='\n' )
          continue;

        if( buf[i]=='\n' && i )
          clipStr = 1;
        else
          bufAdd.putInto( buf[i] );
      }
  }
}

static long ClipConsoleServerTid=-1;
static HFILE readHandle,
             writeHandle,
             consoleHandle1 = 0xffffffffl,
             consoleHandle2 = 0xffffffffl;

void inline noinherit( ULONG h )
{
  ULONG st;

  DosQueryFHState( h, &st );
  DosSetFHState( h, st|OPEN_FLAGS_NOINHERIT );
}

void inline inherit( ULONG h )
{
  ULONG st;

  DosQueryFHState( h, &st );
  DosSetFHState( h, st&(ULONG)(~OPEN_FLAGS_NOINHERIT) );
}

void ClipConsoleInitialize( int needCreate )
{
  if( needCreate )
  {
    APIRET rc;

    if( rc=DosCreatePipe( &readHandle, &writeHandle, 512*1024 ), rc )
    {
      log( Msg_RexxErrClipPipe, rc );
      os2Message( rc );
      return;
    }

    if( ClipConsoleServerTid=_beginthread( ClipConsoleServer, 0, 40960,
                                           (void *)readHandle ),
        ClipConsoleServerTid==-1 )
    {
      log( Msg_ErrClipServ, strError() );
      return;
    }
    else
      log( Msg_ThrClipServ, ClipConsoleServerTid );

    DosDupHandle( 1, &consoleHandle1 );
    DosDupHandle( 2, &consoleHandle2 );

    noinherit( consoleHandle1 );
    noinherit( consoleHandle2 );
    noinherit( readHandle );
    noinherit( writeHandle );
  }

  HFILE hand1 = 1,
	hand2 = 2;

  DosDupHandle( writeHandle, &hand1 );
  DosDupHandle( writeHandle, &hand2 );

  inherit( hand1 );
  inherit( hand2 );
}

void resumeClipServer()
{
  if( ClipConsoleServerTid!=-1 )
  {
    ClipConsoleInitialize( 0 );
    needRead=1;
  }
}

void suspendClipServer()
{
  if( ClipConsoleServerTid!=-1 )
  {
    HFILE hand1 = 1,
          hand2 = 2;

    needRead=0;

    DosDupHandle( consoleHandle1, &hand1 );
    DosDupHandle( consoleHandle2, &hand2 );

    inherit( hand1 );
    inherit( hand2 );
  }
}

void ClipConsoleDeInitialize()
{
  if( ClipConsoleServerTid!=-1 )
  {
    needAbort = 1;

    ULONG written=0;
    char buf[10] ={ 0xff, 0xff, 0xff, 0xff, 0xff,
                    0xff, 0xff, 0xff, 0xff, 0xff };

    while( written!=10 )
      DosWrite( writeHandle, buf, 10, &written );

    DosWaitThread( (PULONG)&ClipConsoleServerTid, DCWW_WAIT );
  }

  suspendClipServer();
}

