#if !defined(__CRC_H)

#define __CRC_H

extern unsigned long crc_32_tab[256];
extern unsigned short crcTab[256];

extern unsigned long hCrc32Tab[256];
extern unsigned short hCrc16Tab[256];

#define Z_UpdateCRC(cp,crc)  (crcTab[(((crc) >> 8) ^ (cp)) & 0xff] ^ ((crc) << 8))
#define Z_32UpdateCRC(c,crc) (crc_32_tab[((int) (crc) ^ (c)) & 0xff] ^ (((crc) >> 8) & 0x00FFFFFFl))

	// CRC-16 CCITT proper

#define CRC16POLY	(0x8408)	// Generator polynomial number
#define CRC16INIT	(0xFFFF)	// Initial CRC value for calculation
#define CRC16POST(crc)	(~(crc))	// CRC Postconditioning before xmit
#define CRC16TEST	(0xF0B8)	// Result to test for at receiver

	// CRC-16 CCITT upside-down

#define CRC16RPOLY	(0x1021)	// Generator polynomial number
#define CRC16RINIT	(0)		// Initial CRC value for calculation
#define CRC16RPOST(crc) (crc)		// CRC Postconditioning before xmit
#define CRC16RTEST	(0)		// Result to test for at receiver

	// CRC-32 CCITT

#define CRC32POLY      (0xEDB88320L)	// Generator polynomial number
#define CRC32INIT      (0xFFFFFFFFL)	// Initial CRC value for calculation
#define CRC32POST(crc) (~(crc))		// CRC Postconditioning before xmit
#define CRC32TEST      (0xDEBB20E3L)	// Result to test for at receiver

void buildHydraCrc();
unsigned short updCrc( char cp, unsigned short crc );
unsigned long updC32( char octet, unsigned long crc);
char * stringCRC( char *s );

#define crc16upd(crctab,crc,c) \
		  ((crctab)[((crc) ^ (c)) & 0xff] ^ ((crc) >> 8))

#define crc32upd(crctab,crc,c) \
		  ((crctab)[((int) (crc) ^ (c)) & 0xff] ^ ((crc) >> 8))

unsigned long crc32block( unsigned long *crctab, unsigned long crc,
                          unsigned char *buf, int len );
unsigned short crc16block( unsigned short *crctab, unsigned short crc,
                           unsigned char *buf, int len );

#endif