#ifndef __ENABLE_H

#define __ENABLE_H

#include <string.h>

#include "regexp.h"
#include "misc.h"

#include "class.h"

enum EnableItemType
{
  EnableItemUnknown=0,
  EnableItemAddress,
  EnableItemFlag
};

class EnableItem : public BaseObject
{
private:
  char *str;
  char *errMsg;
  int isOk;
  EnableItemType type;

  int equal( const BaseObject &t ) const;
  void print( ostream& s ) const;
  char *nameOfClass() const;

  char *stringType() const;

public:

  EnableItem( char *, EnableItemType );
  ~EnableItem();

  char *toString( char *buf, int size ) const;

  int isCorrect() const { return isOk; }
  char *getRegErrorMsg() const { return errMsg; }
  int isUnify( char *test );

  EnableItemType getType() { return type; }
};

class EnableList : public Collection
{
public:
  EnableList();
  
  EnableItem* Find( EnableItem& item, LockMode lock=LockModeNeed ) const;
  EnableItem& operator [] ( const int pos ) const;
};

class EnableIterator : public CollectionIterator
{
public:
  EnableIterator( EnableList& ini );
  
  EnableItem& operator () () const;
};

extern EnableList *enabledList,
		  *disabledList;

extern EnableList *acceptedList,
		  *unAcceptedList;

extern EnableList *timeSyncList;

#endif

