#ifndef __EXECUTE_COMMAND

#define __EXECUTE_COMMAND

#include "sched.h"

int executeCommand( int wait, char **cmd, RunOption o,
                    char *title, char *dosSetting, Schedule *sh );

int makeCmd( FIDOAddress& address, long elapsed,
             char *name, char *actIni, int wait,
             RunOption o, char *title,
             char *dosSetting, Schedule *sh );

char **parseMacro( FIDOAddress& address, long elapsed,
                   char *name, char *actIni, int wait, char *title );

void freeMacro( char **cmd );

class Session : public BaseObject
{
private:
  unsigned long sema;
  unsigned long session;  

  int equal( const BaseObject &t ) const;
  void print( ostream& s ) const;
  char *nameOfClass() const;

public:

  Session( unsigned long _sema, unsigned long _ses );

  unsigned long getSema() const { return sema; }
  unsigned long getSession() const { return session; }
};

class SessionList : public Collection
{
  static unsigned long termQueue;
  static char   *queueName;

public:
  SessionList();
  ~SessionList();

  Session* Find( Session& item, LockMode lock=LockModeNeed ) const;
  Session& operator [] ( const int pos ) const;

  char *getQueueName() const { return queueName; }

  friend static void _Optlink sessionManager( void * );
};

#endif
