#include <string.h>

#include "language.h"
#include "getopt.h"

#define     NOOPT  (int)':'     /* No option */
#define     BADCH  (int)'?'
#define     EMSG   ""

int getopt( int nargc, char * const *nargv, const char *ostr,
            GetOptBlock *block )
{
    register const char *oli;        /* option letter list index */

    if (!*block->place) {            /* update scanning pointer */
      if (block->optind >= nargc || *(block->place = nargv[block->optind]) != '-') {
       block->place = EMSG;
       return(-1);
      }
      if (block->place[1] && *++block->place == '-') {    /* found "--" */
       ++block->optind;
       block->place = EMSG;
       return(-1);
      }
    }
               /* option letter okay? */
    if ((block->optopt = (int)*block->place++) == (int)':' ||
        !(oli = strchr(ostr, block->optopt), oli)) {
      /*
       * if the user didn't specify '-' as an option,
       * assume it means -1.
       */
      if (block->optopt == (int)'-')
       return(-1);
      if (!*block->place)
       ++block->optind;
      if (*ostr != ':')
       block->error = Msg_ErrOptionIllegal;
      return(BADCH);
    }

    if (*++oli != ':') {       /* don't need argument */
      block->optarg = NULL;
      if (!*block->place)
       ++block->optind;
    } else {          /* need an argument */
      if (*block->place)           /* no white space */
       block->optarg = block->place;
      else if (nargc <= ++block->optind) {   /* no arg */
       block->place = EMSG;
       if (*ostr != ':')
        block->error = Msg_ErrOptionIllegalArg;
       return((*ostr == ':') ? NOOPT : BADCH);
      }
       else           /* white space */
       block->optarg = nargv[block->optind];
      block->place = EMSG;
      ++block->optind;
    }
    return(block->optopt);           /* dump back option letter */
}
