#define INCL_DOS
#define INCL_DOSEXCEPTIONS
#include <os2.h>

#include <time.h>
#include <stdio.h>
#include <process.h>
#include <builtin.h>

#include "except.h"

#include "language.h"

#include "hdialog.h"
#include "misc.h"
#include "zinter.h"
#include "hydraint.h"
#include "filetype.h"
#include "session.h"

static Window *zWnd = NULL;

static volatile long rxLength = 0,
                     startRxPos = 0,
                     curRxPos = 0;

static volatile long txLength = 0,
                     startTxPos = 0,
                     curTxPos = 0;

volatile long startRxTime = 0,
              startTxTime = 0;

static volatile char abortDrawZInfo = 0;
static long drawThr=0xffffffffl;

volatile char hSend = 0;
volatile char hReceive = 0;

volatile int  hinfoRxTry = 0;
volatile long hinfoRxPos = 0;
volatile int  hinfoRxCps = 500000;

volatile int  hinfoTxTry = 0;
volatile long hinfoTxPos = 0;
volatile int  hinfoTxCps = 500000;

volatile char timeDelimiter = '/';

char hydraCpsOld[80] = { 0 };

static FileType inFileType;

volatile long hSendStartTime = 0;
volatile long hReceiveStartTime = 0;

void _Optlink drawHInfoFic( void * )
{
  registerExceptionHandler

  for( ; !abortDrawZInfo; sleep( 100 ) )
  {
    long elapsedTime( getTimeMark() );

    curRxPos = hinfoRxPos;
    curTxPos = hinfoTxPos;

    if( hSend )
    {
      long elapsed( elapsedTime - startTxTime );

      if( elapsed <= 0 )
        elapsed = 1;

      elapsed = (curTxPos-startTxPos)/elapsed;

      if( elapsed < 0 )
        elapsed = 0;

      hinfoTxCps = int(elapsed);
    }

    if( hReceive )
    {
      long elapsed( elapsedTime - startRxTime );

      if( elapsed <= 0 )
        elapsed = 1;

      elapsed = (curRxPos-startRxPos)/elapsed;

      if( elapsed < 0 )
        elapsed = 0;

      hinfoRxCps = int(elapsed);
    }
  }

  deRegisterExceptionHandler
}

void _Optlink drawHInfo( void * )
{
  registerExceptionHandler

  char buf[80];

  int tryCntTx = -1;
  long posTx = -1;

  int tryCntRx = -1;
  long posRx = -1;

  long wasElapsed = -1;

  for( +*zWnd; !abortDrawZInfo; sleep( 100 ) )
  {
    long elapsedTime( getTimeMark() );

    if( wasElapsed!=elapsedTime )
    {
      char cps1[32];
      char cps2[32];

      if( hSend )
      {
        if( posTx!=hinfoTxPos )
        {
          char *ss = strNumber( hinfoTxPos );

          posTx = hinfoTxPos;
          sprintf( buf, "%s, %lu%%", ss,
                   makePercent( txLength ? txLength : 1, hinfoTxPos ) );
          zWnd->drawTransactField( 10, 3, stdColor, buf );
          curTxPos = posTx;
          delete ss;
        }

        if( hinfoTxTry && hinfoTxTry!=tryCntTx )
        {
          tryCntTx = hinfoTxTry;
          sprintf( buf, "[%2d]", tryCntTx );
          zWnd->drawTransactField( 21, 3, stdColor, buf );
        }

        long elapsed( elapsedTime );

        elapsed -= startTxTime;

        long oldElapsed( elapsed );

        if( elapsed <= 0 )
          elapsed = 1;

        elapsed = (curTxPos-startTxPos)/elapsed;

        if( elapsed < 0 )
          elapsed = 0;

        char *ss = strNumber( elapsed );

        strcpy( cps1, ss );
        delete ss;

        long work( elapsed ? elapsed : comPort->getLastBaud()/10 );

        if( !work )
          work = 1;

        long rest( (txLength - curTxPos) / work );

        char buf1[32],
             buf2[32];

        makeTime( buf1, oldElapsed );
        makeTime( buf2, rest );
        strcpy( buf, buf1 );
        strcat( buf, " / " );
        strcat( buf, buf2 );

        zWnd->drawTransactField( 10, 4, stdColor, buf );
        hinfoTxCps = int(elapsed);
      }
      else
        strcpy( cps1, Msg_ZDNone );

      if( hReceive )
      {
        if( posRx!=hinfoRxPos )
        {
          char *ss = strNumber( hinfoRxPos );

          posRx = hinfoRxPos;
          sprintf( buf, "%s, %lu%%", ss,
                   makePercent( rxLength ? rxLength : 1, hinfoRxPos ) );
          zWnd->drawTransactField( 10, 6, stdColor, buf );
          curRxPos = posRx;
          delete ss;
        }

        if( hinfoRxTry && hinfoRxTry!=tryCntRx )
        {
          tryCntRx = hinfoRxTry;
          sprintf( buf, "[%2d]", tryCntRx );
          zWnd->drawTransactField( 21, 6, stdColor, buf );
        }

        long elapsed = elapsedTime;

        elapsed -= startRxTime;

        long oldElapsed = elapsed;

        if( elapsed <= 0 )
          elapsed = 1;

        elapsed = (curRxPos-startRxPos)/elapsed;

        if( elapsed < 0 )
          elapsed = 0;

        char *ss = strNumber( elapsed );

        strcpy( cps2, ss );
        delete ss;

        long work( elapsed ? elapsed : comPort->getLastBaud()/10 );

        if( !work )
          work = 1;

        long rest( (rxLength - curRxPos) / work );

        char buf1[32],
             buf2[32];

        makeTime( buf1, oldElapsed );
        makeTime( buf2, rest );
        strcpy( buf, buf1 );
        strcat( buf, " / " );
        strcat( buf, buf2 );

        zWnd->drawTransactField( 10, 7, stdColor, buf );
        hinfoRxCps = int(elapsed);
      }
      else
        strcpy( cps2, Msg_ZDNone );

      char cps[80];
      static char cpsOld[80] = { 0 };

      buf[0] = ' ';
      buf[1] = timeDelimiter;
      buf[2] = ' ';
      buf[3] = 0;
      strcpy( cps, cps1 );
      strcat( cps, buf );
      strcat( cps, cps2 );

      if( stricmp( cps, hydraCpsOld ) )
      {
        strcpy( hydraCpsOld, cps );
        zWnd->drawTransactField( 10, 8, stdColor, cps );
      }
    }
  }

  deRegisterExceptionHandler
}

void hydraDisplayStart()
{
  if( zWnd!=NULL )
  {
    log( "hydraDisplayStart -  㦥 !" );
    return;
  }

  hinfoRxTry = 0;
  hinfoRxPos = 0;
  hinfoRxCps = 0;

  hinfoTxTry = 0;
  hinfoTxPos = 0;
  hinfoTxCps = 0;

  rxLength = 0;
  startRxTime = getTimeMark();
  startRxPos = 0;
  curRxPos = 0;

  txLength = 0;
  startTxTime = getTimeMark();
  startTxPos = 0;
  curTxPos = 0;

  hSend = 0;
  hReceive = 0;
  zReceiveMode = 0;

  abortDrawZInfo = 0;

  if( !detachedSession )
  {
    int delta = (miscInfo.state1&StatusLine)==StatusLine ? 0 : 1;

    if( terminalActive )
      zWnd = new Window( Z_ScreenWidth-28, 3-delta, 27, 11, stdColor,
                         NULL, BS_SINGLELINE, DS_LOWERRIGHT );
    else
      zWnd = new Window( Z_ScreenWidth-25, 3-delta, 25, 9, stdColor );

    zWnd->drawTransact( 2, 2, stdColor, Msg_HScrSend );
    zWnd->drawTransact( 10, 2, stdColor, Msg_ZDNone );

    zWnd->drawTransact( 2, 3, stdColor, Msg_ZDFilePos );
    zWnd->drawTransact( 10, 3, stdColor, Msg_ZDNone );

    zWnd->drawTransact( 2, 4, stdColor, Msg_ZDFileTime );
    zWnd->drawTransact( 10, 4, stdColor, Msg_ZDNone );

    zWnd->drawTransact( 2, 5, stdColor, Msg_HScrRecv );
    zWnd->drawTransact( 10, 5, stdColor, Msg_ZDNone );

    zWnd->drawTransact( 2, 6, stdColor, Msg_ZDFilePos );
    zWnd->drawTransact( 10, 6, stdColor, Msg_ZDNone );

    zWnd->drawTransact( 2, 7, stdColor, Msg_ZDFileTime );
    zWnd->drawTransact( 10, 7, stdColor, Msg_ZDNone );

    zWnd->drawTransact( 2, 8, stdColor, Msg_ZDFileCps );
    zWnd->drawTransact( 10, 8, stdColor, Msg_ZDNone );

    drawThr = _beginthread( drawHInfo, 0, 40960, 0 );
  }
  else
    drawThr = _beginthread( drawHInfoFic, 0, 40960, 0 );
}

void hydraDisplayEnd()
{
  abortDrawZInfo = 1;
  DosWaitThread( (PTID)&drawThr, DCWW_WAIT );

  if( !detachedSession )
  {
    delete zWnd;
    zWnd = NULL;
  }
}

void hydraDisplaySendName( char *realname, long file_length, char *alias,
                           long start )
{
  txLength = file_length;
  hSend = 1;

  long appro( (file_length*10) / comPort->getLastBaud() );
  char *file = fileName( realname ),
       *ss = strNumber( file_length );

  makeFileCase( realname );

  log( Msg_HDSend, file,
       alias==NULL ? "" : " -> ", alias==NULL ? "" : alias,
       Crc32 ? 32 : 16,
       ss, appro/60, int( appro%60 ),
       msgOfFileType( alias!=NULL ? alias : file, NULL )
     );

  delete ss;

  startTxTime = getTimeMark();

  if( !hSendStartTime )
    hSendStartTime = startTxTime;

  startTxPos = start;
  curTxPos = 0;

  if( zWnd==NULL )
    return;

  zWnd->drawTransactField( 10, 2, stdColor, alias!=NULL ? alias : file );
  hydraDisplaySendPos( start );
}

void hydraDisplayReceiveName( char *realname, long file_length, long start )
{
  rxLength = file_length;
  hReceive = 1;
  zReceiveMode = 1;
  msgOfFileType( realname, &inFileType );

  long appro( (file_length*10) / comPort->getLastBaud() );
  char *file = fileName( realname ),
       *ss = strNumber( file_length );

  makeFileCase( realname );

  log( Msg_HDReceive, file,
       Crc32 ? 32 : 16,
       ss, appro/60, int( appro%60 ),
       msgOfFileType( file, NULL ) );

  delete ss;

  startRxTime = getTimeMark();

  if( !hReceiveStartTime )
    hReceiveStartTime = startRxTime;

  startRxPos = start;
  curRxPos = 0;

  if( zWnd==NULL )
    return;

  zWnd->drawTransact( 10, 5, stdColor, file );
  hydraDisplayReceivePos( start );
}

void hydraDisplayDone( long iosize, long start, int receive )
{
  long elapsed = getTimeMark();
  int delta = (miscInfo.state1&StatusLine)==StatusLine ? 0 : 1;

  if( !terminalActive && !rexxTransfer )
  {
    int line;
    long ela( elapsed ),
         str,
	 size;

    wndQueue = brdColor;

    if( receive )
    {
      char buf[40];

      zInCount++;
      zInBytes += iosize;

      switch( inFileType )
      {
      case FileMail:
	sessionBinaryInfo.netRecv += iosize;
	break;

      case FileXMail:
	sessionBinaryInfo.xmRecv += iosize;
	break;

      default:
	sessionBinaryInfo.filesRecv += iosize;
	break;
      }

      char *ss = strNumber( zInBytes );

      sprintf( buf, "%3d/%s", zInCount, ss );
      wndQueue( 40, 9+delta ).clearLine();
      wndQueue << buf;
      delete ss;

      int percent( (hisFiles+hisMail) ? makePercent( hisFiles+hisMail, zInBytes )
                                      : 101 );
      char percentStr[16];

      if( percent>100 )
        strcpy( percentStr, ">100%" );
      else
        sprintf( percentStr, "%lu%%", percent );

      wndQueue( 60, 9+delta ) << percentStr;
      line = 9+delta;
      size = zInBytes;
      str = hReceiveStartTime;
    }
    else
    {
      char buf[40];

      zOutCount++;
      zOutBytes += iosize;

      char *ss = strNumber( zOutBytes );

      sprintf( buf, "%3d/%s", zOutCount, ss );
      wndQueue( 40, 10+delta ).clearLine();
      wndQueue << buf;
      delete ss;

      int percent( (ourFiles+ourMail) ? makePercent( ourFiles+ourMail, zOutBytes )
                                      : 101 );
      char percentStr[16];

      if( percent>100 )
        strcpy( percentStr, ">100%" );
      else
        sprintf( percentStr, "%lu%%", percent );

      wndQueue( 60, 10+delta ) << percentStr;
      line = 10+delta;
      size = zOutBytes;
      str = hSendStartTime;
    }

    ela -= str;

    if( ela <= 0 )
      ela = 1;

    ela = size / ela;

    if( ela<0 )
      ela = 0;

    str = (ela * 1000L) / comPort->getLastBaud();

    wndQueue( 68, line ) << int(ela);

    {
      char buf[64];

      sprintf( buf, "%lu%%", str );
      wndQueue( 74, line ).field( buf );
    }
  }

  long startTime = receive ? startRxTime : startTxTime;

  elapsed -= startTime;

  long tt( elapsed );

  if( tt < 0 )
    tt = 0;

  if( elapsed <= 0 )
    elapsed = 1;

  elapsed = iosize / elapsed;

  if( elapsed<0 )
    elapsed = 0;

  long percent = makePercent( comPort->getLastBaud(), elapsed*10 );

  char *ss = strNumber( iosize );

  if( !start )
    log( receive ? Msg_HDTotalRec : Msg_HDTotalSent,
         tt/60, int(tt%60), ss, elapsed, percent );
  else
  {
    char *ss1 = strNumber( start );

    log( receive ? Msg_HDTotalFromRec : Msg_HDTotalFromSent,
         tt/60, int(tt%60), ss, ss1, elapsed, percent );
    delete ss1;
  }

  delete ss;

  if( !receive && telebitFuckinCorrectionTimes )
    log( Msg_InfoFuckinTelebitCorrection );

  if( !receive )
    hSend = 0;
  else
  {
    hReceive = 0;
    zReceiveMode = 0;
  }

  if( zWnd==NULL )
    return;

  if( !receive )
  {
    zWnd->drawTransact( 10, 2, stdColor, Msg_ZDNone );
    zWnd->drawTransact( 10, 3, stdColor, Msg_ZDNone );
    zWnd->drawTransact( 10, 4, stdColor, Msg_ZDNone );
  }
  else
  {
    zWnd->drawTransact( 10, 5, stdColor, Msg_ZDNone );
    zWnd->drawTransact( 10, 6, stdColor, Msg_ZDNone );
    zWnd->drawTransact( 10, 7, stdColor, Msg_ZDNone );
  }
}
