#define INCL_DOSFILEMGR
#include <os2.h>

#include <malloc.h>
#include <stdio.h>
#include <time.h>
#include <string.h>

#include "heap.h"

long HeapStat::isUsed = 0,
     HeapStat::isFree = 0,
     HeapStat::isUndef = 0,
     HeapStat::totUsed = 0,
     HeapStat::totFree = 0,
     HeapStat::totUndef = 0,
     HeapStat::heapEnd = 0;
const char* HeapStat::badFile = NULL;
const void *HeapStat::badObject = NULL;
size_t HeapStat::badLine = 0;

char heapDebug = 0;

HeapStat::HeapStat()
{
  isUsed = 0;
  isFree = 0;
  isUndef = 0;
  totUsed = 0;
  totFree = 0;
  totUndef = 0;
  heapEnd = 0;
  badLine = 0;
  badFile = NULL;
  badObject = NULL;

  _heapmin();
  _heap_walk( heapBack );
}

int _Optlink heapBack( const void *object, size_t size, int flag, int status,
                       const char* file, size_t line )
{
  HeapStat::heapEnd = status;

  if( status==_HEAPBADNODE && HeapStat::badFile!=NULL )
  {
    HeapStat::badFile = file;
    HeapStat::badObject = object;
    HeapStat::badLine = line;
  }

  switch( flag )
  {
  case _USEDENTRY:
    HeapStat::isUsed += size;
    HeapStat::totUsed++;
    break;

  case _FREEENTRY:
    HeapStat::isFree += size;
    HeapStat::totFree++;
    break;

  default:
    HeapStat::isUndef += size;
    HeapStat::totUndef++;
    break;
  }

  return 0;
}

void heapState( char *pr )
{
  if( heapDebug<1 )
    return;

  HeapStat heap;
  char buf[80];
  long getTaskNumber();
  FILE *ou;
  struct tm *localTime( long * );

  sprintf( buf, "$Heap.%lu", getTaskNumber() );
  ou = fopen( buf, "a" );

  if( ou )
  {
    time_t elapsed( time(0) );
    struct tm *tt( localTime( &elapsed ) );
    char r[32];
    strftime( r, 31, "%d/%m %H:%M:%S", tt );
    
    fprintf( ou, "%s %s %01d U:%08lu,%05lu F:%08lu,%05lu S:%08lu,%05lu "
                 "?:%08lu,%05lu %01d B:%08lu,%04lu,%s\n",
                 r, pr,
                 _heapchk(),
                 heap.isUsed, heap.totUsed,
                 heap.isFree, heap.totFree,
                 heap.isUsed+heap.isFree, heap.totUsed+heap.totFree,
                 heap.isUndef, heap.totUndef,
                 heap.heapEnd, heap.badObject,
                 heap.badLine, heap.badFile );
    fclose( ou );
  }
}

/*
static int dumpFile;

int _Optlink heapBackDump( const void *object, size_t size, int flag, int status,
                           const char* file, size_t line )
{
  if( flag==_FREEENTRY )
    return 0;

  static char buf[512*1024];
  unsigned long how;
  sprintf( buf, "%c%d %08x:%08x %05d %s ",
           flag==_USEDENTRY ? 'U' : (flag==_FREEENTRY ? 'F' : '?'),
           status,
           object, size,
           line, file );

  for( size_t i(0); i<size; i++ )
    sprintf( buf+strlen(buf), "%02x ", ((const char *)object)[i] );

  strcat( buf, "\n" );

  DosWrite( dumpFile, buf, strlen(buf), &how );
  return 0;
}

void heapDump( char *pr )
{
  if( heapDebug<10 )
    return;

  char buf[80];
  long getTaskNumber();
  FILE *ou;
  struct tm *localTime( long * );

  sprintf( buf, "$Heap.%lu", getTaskNumber() );
  ou = fopen( buf, "a" );

  if( ou )
  {
    time_t elapsed( time(0) );
    struct tm *tt( localTime( &elapsed ) );
    char r[32];
    strftime( r, 31, "%d/%m %H:%M:%S", tt );
    
    fprintf( ou, "%s %s\n", r, pr );
    fflush( ou );
    dumpFile = fileno( ou );
    _heapmin();
    _heap_walk( heapBackDump );
    fclose( ou );
  }
}
*/