#define INCL_WINSHELLDATA
#define INCL_PM
#include <os2.h>

#undef BS_NOBORDER

#include "language.h"

#include "misc.h"
#include "dinamic.h"

char capName[stringLen] = "Brake!.Cap";
char trnName[stringLen] = "";
char terminalNumber[stringLen] = "";
int trnUploadType = 1;

char pollString[stringLen] = "";
int pollFlavour = 1;

char dropString[stringLen] = "";
int dropFlavour = 1;

char sendString[stringLen] = "";
char sendFile[stringLen] = "";
Flavour sendFlavour = normalFlavour;

char getString[stringLen] = "";
char getFile[stringLen] = "";
Flavour getFlavour = normalFlavour;

void prfError( char *w, int save )
{
  log( Msg_LogUnableDo, save ? Msg_LogUnableWSave : Msg_LogUnableWRest, w );
}

HINI iniFileHandle;

void deInitProfile()
{
  if( noPMFeatures || detachedSession )
    return;

  if( iniFileHandle!=HINI_USERPROFILE )
    BrakePrfCloseProfile( iniFileHandle );
}

void initProfile()
{
  if( noPMFeatures || detachedSession )
    return;

  extern char *prfName;

  HAB hab( BrakeWinQueryAnchorBlock( HWND_DESKTOP ) );

  if( hab==NULLHANDLE )
  {
    iniFileHandle = HINI_USERPROFILE;
    log( Msg_ErrPrfNoHAB );
  }
  else
  {
    iniFileHandle = BrakePrfOpenProfile( hab, prfName );

    if( iniFileHandle==NULLHANDLE )
    {
      iniFileHandle = HINI_USERPROFILE;
      log( Msg_ErrPrfOpen, prfName );
    }
  }
}

void initFileInfo( int save )
{
  if( noPMFeatures || detachedSession )
    return;

  if( save )
  {
    if( BrakePrfWriteProfileString( iniFileHandle, pszAppBrake,
	                            (PSZ)"TerminalNumber",
			            (PSZ)terminalNumber ) == FALSE )
      prfError( Msg_LogUnableWPhone, save );

    if( BrakePrfWriteProfileString( iniFileHandle, pszAppBrake,
			            (PSZ)"CaptureName",
			            (PSZ)capName ) == FALSE )
      prfError( Msg_LogUnableWCAP, save );

    if( BrakePrfWriteProfileString( iniFileHandle, pszAppBrake,
			            (PSZ)"TerminalTransmitName",
			            (PSZ)trnName ) == FALSE )
      prfError( Msg_LogUnableWTSend, save );

    if( BrakePrfWriteProfileData( iniFileHandle, pszAppBrake,
			          (PSZ)"TerminalTransmitMode",
			          (PVOID)&trnUploadType,
			          (ULONG)sizeof( trnUploadType ) ) == FALSE )
      prfError( Msg_LogUnableWTMode, save );

    if( BrakePrfWriteProfileString( iniFileHandle, pszAppBrake,
			            (PSZ)"PollAddress",
			            (PSZ)pollString ) == FALSE )
      prfError( Msg_LogUnableWPoll, save );

    if( BrakePrfWriteProfileString( iniFileHandle, pszAppBrake,
			            (PSZ)"DropAddress",
			            (PSZ)dropString ) == FALSE )
      prfError( Msg_LogUnableWDrop, save );

    if( BrakePrfWriteProfileString( iniFileHandle, pszAppBrake,
			            (PSZ)"SendAddress",
			            (PSZ)sendString ) == FALSE )
      prfError( Msg_LogUnableWSAddr, save );

    if( BrakePrfWriteProfileString( iniFileHandle, pszAppBrake,
			            (PSZ)"SendFile",
			            (PSZ)sendFile ) == FALSE )
      prfError( Msg_LogUnableWSFile, save );

    if( BrakePrfWriteProfileString( iniFileHandle, pszAppBrake,
			            (PSZ)"GetAddress",
			            (PSZ)getString ) == FALSE )
      prfError( Msg_LogUnableWRAddr, save );

    if( BrakePrfWriteProfileString( iniFileHandle, pszAppBrake,
			            (PSZ)"GetFile",
			            (PSZ)getFile ) == FALSE )
      prfError( Msg_LogUnableWRFile, save );

    if( BrakePrfWriteProfileData( iniFileHandle, pszAppBrake,
			          (PSZ)"PollFlavour",
			          (PVOID)&pollFlavour,
			          (ULONG)sizeof( pollFlavour ) ) == FALSE )
      prfError( Msg_LogUnableWPFlav, save );

    if( BrakePrfWriteProfileData( iniFileHandle, pszAppBrake,
			          (PSZ)"DropFlavour",
			          (PVOID)&dropFlavour,
			          (ULONG)sizeof( dropFlavour ) ) == FALSE )
      prfError( Msg_LogUnableWDFlav, save );

    if( BrakePrfWriteProfileData( iniFileHandle, pszAppBrake,
			          (PSZ)"SendFlavour",
			          (PVOID)&sendFlavour,
			          (ULONG)sizeof( sendFlavour ) ) == FALSE )
      prfError( Msg_LogUnableWSFlav, save );

    if( BrakePrfWriteProfileData( iniFileHandle, pszAppBrake,
			          (PSZ)"GetFlavour",
			          (PVOID)&getFlavour,
			          (ULONG)sizeof( getFlavour ) ) == FALSE )
      prfError( Msg_LogUnableWRFlav, save );

  }
  else
  {
    if( BrakePrfQueryProfileString( iniFileHandle, pszAppBrake,
			            (PSZ)"TerminalNumber",
			            NULL,
			            (PVOID)terminalNumber,
			            (ULONG)stringLen ) == FALSE )
      prfError( Msg_LogUnableWPhone, save );

    if( BrakePrfQueryProfileString( iniFileHandle, pszAppBrake,
			            (PSZ)"CaptureName",
			            NULL,
			            (PVOID)capName,
			            (ULONG)stringLen ) == FALSE )
      prfError( Msg_LogUnableWCAP, save );

    if( BrakePrfQueryProfileString( iniFileHandle, pszAppBrake,
			            (PSZ)"TerminalTransmitName",
			            NULL,
			            (PVOID)trnName,
			            (ULONG)stringLen ) == FALSE )
      prfError( Msg_LogUnableWTSend, save );

    ULONG len;

    len = sizeof( trnUploadType );
    if( BrakePrfQueryProfileData( iniFileHandle, pszAppBrake,
			          (PSZ)"TerminalTransmitMode",
			          (PVOID)&trnUploadType,
			          &len ) == FALSE )
      prfError( Msg_LogUnableWTMode, save );

    if( BrakePrfQueryProfileString( iniFileHandle, pszAppBrake,
			            (PSZ)"PollAddress",
			            NULL,
			            (PVOID)pollString,
			            (ULONG)stringLen ) == FALSE )
      prfError( Msg_LogUnableWPoll, save );

    if( BrakePrfQueryProfileString( iniFileHandle, pszAppBrake,
			            (PSZ)"DropAddress",
			            NULL,
			            (PVOID)dropString,
			            (ULONG)stringLen ) == FALSE )
      prfError( Msg_LogUnableWDrop, save );

    if( BrakePrfQueryProfileString( iniFileHandle, pszAppBrake,
			            (PSZ)"SendAddress",
			            NULL,
			            (PVOID)sendString,
			            (ULONG)stringLen ) == FALSE )
      prfError( Msg_LogUnableWSAddr, save );

    if( BrakePrfQueryProfileString( iniFileHandle, pszAppBrake,
			            (PSZ)"SendFile",
			            NULL,
			            (PVOID)sendFile,
			            (ULONG)stringLen ) == FALSE )
      prfError( Msg_LogUnableWSFile, save );

    if( BrakePrfQueryProfileString( iniFileHandle, pszAppBrake,
			            (PSZ)"GetAddress",
			            NULL,
			            (PVOID)getString,
			            (ULONG)stringLen ) == FALSE )
      prfError( Msg_LogUnableWRAddr, save );

    if( BrakePrfQueryProfileString( iniFileHandle, pszAppBrake,
			            (PSZ)"GetFile",
			            NULL,
			            (PVOID)getFile,
			            (ULONG)stringLen ) == FALSE )
      prfError( Msg_LogUnableWRFile, save );

    len = sizeof( pollFlavour );
    if( BrakePrfQueryProfileData( iniFileHandle, pszAppBrake,
			          (PSZ)"PollFlavour",
			          (PVOID)&pollFlavour,
			          &len ) == FALSE )
      prfError( Msg_LogUnableWPFlav, save );

    len = sizeof( dropFlavour );
    if( BrakePrfQueryProfileData( iniFileHandle, pszAppBrake,
			          (PSZ)"DropFlavour",
			          (PVOID)&dropFlavour,
			          &len ) == FALSE )
      prfError( Msg_LogUnableWDFlav, save );

    len = sizeof( sendFlavour );
    if( BrakePrfQueryProfileData( iniFileHandle, pszAppBrake,
			          (PSZ)"SendFlavour",
			          (PVOID)&sendFlavour,
			          &len ) == FALSE )
      prfError( Msg_LogUnableWSFlav, save );

    len = sizeof( getFlavour );
    if( BrakePrfQueryProfileData( iniFileHandle, pszAppBrake,
			          (PSZ)"GetFlavour",
			          (PVOID)&getFlavour,
			          &len ) == FALSE )
      prfError( Msg_LogUnableWRFlav, save );

  }
}
