#ifndef __KEY_H

#define __KEY_H

extern char detachedSession;

int InitKbdSystem( void );

int keyGet( void );
void keyClear( void );
int keyPressed( void );
void setBinaryKbdMode( void );
void keyCtrlCFound( void );

void keyBoardLock( void );
void keyBoardUnLock( void );
int keyBoardIsLocked( void );

void disableScreenSaver( void );
void enableScreenSaver( void );

#define key_F1        0x3b00
#define key_F2        0x3c00
#define key_F3        0x3d00
#define key_F4        0x3e00
#define key_F5        0x3f00
#define key_F6        0x4000
#define key_F7        0x4100
#define key_F8        0x4200
#define key_F9        0x4300
#define key_F10       0x4400

#define key_Shift_F1  0x5400
#define key_Shift_F2  0x5500
#define key_Shift_F3  0x5600
#define key_Shift_F4  0x5700
#define key_Shift_F5  0x5800
#define key_Shift_F6  0x5900
#define key_Shift_F7  0x5a00
#define key_Shift_F8  0x5b00
#define key_Shift_F9  0x5c00
#define key_Shift_F10 0x5d00

#define key_Alt_F12   0x8c00

#define key_Ctrl_A    ('A'-'A'+1)
#define key_Ctrl_B    ('B'-'A'+1)
#define key_Ctrl_C    ('C'-'A'+1)
#define key_Ctrl_D    ('D'-'A'+1)
#define key_Ctrl_E    ('E'-'A'+1)
#define key_Ctrl_O    ('O'-'A'+1)
#define key_Ctrl_P    ('P'-'A'+1)
#define key_Ctrl_Q    ('Q'-'A'+1)
#define key_Ctrl_S    ('S'-'A'+1)

#define key_Alt_A     0x1e00
#define key_Alt_C     0x2e00
#define key_Alt_D     0x2000
#define key_Alt_E     0x1200
#define key_Alt_G     0x2200
#define key_Alt_H     0x2300
#define key_Alt_I     0x1700
#define key_Alt_L     0x2600
#define key_Alt_M     0x3200
#define key_Alt_N     0x3100
#define key_Alt_O     0x1800
#define key_Alt_P     0x1900
#define key_Alt_Q     0x1000
#define key_Alt_R     0x1300
#define key_Alt_S     0x1f00
#define key_Alt_T     0x1400
#define key_Alt_V     0x2f00
#define key_Alt_X     0x2d00

#define key_UpArr     0x4800
#define key_LtArr     0x4b00
#define key_RtArr     0x4d00
#define key_DnArr     0x5000

#define key_PgUp      0x4900
#define key_PgDn      0x5100

#define key_Ins       0x5200
#define key_Del       0x5300
#define key_Home      0x4700
#define key_End       0x4f00

#define key_Ctrl_UpArr 0x8d00
#define key_Ctrl_DnArr 0x9100
#define key_Alt_Enter  0x1c00

#endif
