#include "keycd.h"

KeyCode codeTable[] =
{               	
  { "f1",		0x3b00 },
  { "f2",		0x3c00 },
  { "f3",		0x3d00 },
  { "f4",		0x3e00 },
  { "f5",		0x3f00 },
  { "f6",		0x4000 },
  { "f7",		0x4100 },
  { "f8",		0x4200 },
  { "f9",		0x4300 },
  { "f10",		0x4400 },
  { "f11",		0x8500 },
  { "f12",		0x8600 },
  { "alt-f1",		0x6800 },
  { "alt-f2",		0x6900 },
  { "alt-f3",		0x6a00 },
  { "alt-f4",		0x6b00 },
  { "alt-f5",		0x6c00 },
  { "alt-f6",		0x6d00 },
  { "alt-f7",		0x6e00 },
  { "alt-f8",		0x6f00 },
  { "alt-f9",		0x7000 },
  { "alt-f10",		0x7100 },
  { "alt-f11",		0x8b00 },
  { "alt-f12",		0x8c00 },
  { "shift-f1",		0x5400 },
  { "shift-f2",		0x5500 },
  { "shift-f3",		0x5600 },
  { "shift-f4",		0x5700 },
  { "shift-f5",		0x5800 },
  { "shift-f6",		0x5900 },
  { "shift-f7",		0x5a00 },
  { "shift-f8",		0x5b00 },
  { "shift-f9",		0x5c00 },
  { "shift-f10",	0x5d00 },
  { "shift-f11",	0x8700 },
  { "shift-f12",	0x8800 },
  { "ctrl-f1",		0x5e00 },
  { "ctrl-f2",		0x5f00 },
  { "ctrl-f3",		0x6000 },
  { "ctrl-f4",		0x6100 },
  { "ctrl-f5",		0x6200 },
  { "ctrl-f6",		0x6300 },
  { "ctrl-f7",		0x6400 },
  { "ctrl-f8",		0x6500 },
  { "ctrl-f9",		0x6600 },
  { "ctrl-f10",		0x6700 },
  { "ctrl-f11",		0x8900 },
  { "ctrl-f12",		0x8a00 },
  { "!",		0x0021 },
  { "\"",		0x0022 },
  { "#",		0x0023 },
  { "$",		0x0024 },
  { "%",		0x0025 },
  { "&",		0x0026 },
  { "'",		0x0027 },
  { "(",		0x0028 },
  { ")",		0x0029 },
  { "*",		0x002a },
  { "+",		0x002b },
  { ",",		0x002c },
  { "-",		0x002d },
  { ".",		0x002e },
  { "/",		0x002f },
  { "0",		0x0030 },
  { "1",		0x0031 },
  { "2",		0x0032 },
  { "3",		0x0033 },
  { "4",		0x0034 },
  { "5",		0x0035 },
  { "6",		0x0036 },
  { "7",		0x0037 },
  { "8",		0x0038 },
  { "9",		0x0039 },
  { ":",		0x003a },
  { ";",		0x003b },
  { "<",		0x003c },
  { "=",		0x003d },
  { ">",		0x003e },
  { "?",		0x003f },
  { "@",		0x0040 },
  { "A",		0x0041 },
  { "B",		0x0042 },
  { "C",		0x0043 },
  { "D",		0x0044 },
  { "E",		0x0045 },
  { "F",		0x0046 },
  { "G",		0x0047 },
  { "H",		0x0048 },
  { "I",		0x0049 },
  { "J",		0x004a },
  { "K",		0x004b },
  { "L",		0x004c },
  { "M",		0x004d },
  { "N",		0x004e },
  { "O",		0x004f },
  { "P",		0x0050 },
  { "Q",		0x0051 },
  { "R",		0x0052 },
  { "S",		0x0053 },
  { "T",		0x0054 },
  { "U",		0x0055 },
  { "V",		0x0056 },
  { "W",		0x0057 },
  { "X",		0x0058 },
  { "Y",		0x0059 },
  { "Z",		0x005a },
  { "[",		0x005b },
  { "\\",		0x005c },
  { "]",		0x005d },
  { "^",		0x005e },
  { "_",		0x005f },
  { "`",		0x0060 },
  { "a",		0x0061 },
  { "b",		0x0062 },
  { "c",		0x0063 },
  { "d",		0x0064 },
  { "e",		0x0065 },
  { "f",		0x0066 },
  { "g",		0x0067 },
  { "h",		0x0068 },
  { "i",		0x0069 },
  { "j",		0x006a },
  { "k",		0x006b },
  { "l",		0x006c },
  { "m",		0x006d },
  { "n",		0x006e },
  { "o",		0x006f },
  { "p",		0x0070 },
  { "q",		0x0071 },
  { "r",		0x0072 },
  { "s",		0x0073 },
  { "t",		0x0074 },
  { "u",		0x0075 },
  { "v",		0x0076 },
  { "w",		0x0077 },
  { "x",		0x0078 },
  { "y",		0x0079 },
  { "z",		0x007a },
  { "A",		0x0041 },
  { "B",		0x0042 },
  { "C",		0x0043 },
  { "D",		0x0044 },
  { "E",		0x0045 },
  { "F",		0x0046 },
  { "G",		0x0047 },
  { "H",		0x0048 },
  { "I",		0x0049 },
  { "J",		0x004a },
  { "K",		0x004b },
  { "L",		0x004c },
  { "M",		0x004d },
  { "N",		0x004e },
  { "O",		0x004f },
  { "P",		0x0050 },
  { "Q",		0x0051 },
  { "R",		0x0052 },
  { "S",		0x0053 },
  { "T",		0x0054 },
  { "U",		0x0055 },
  { "V",		0x0056 },
  { "W",		0x0057 },
  { "X",		0x0058 },
  { "Y",		0x0059 },
  { "Z",		0x005a },
  { "ctrl-a",		0x0001 },
  { "ctrl-b",		0x0002 },
  { "ctrl-c",		0x0003 },
  { "ctrl-d",		0x0004 },
  { "ctrl-e",		0x0005 },
  { "ctrl-f",		0x0006 },
  { "ctrl-g",		0x0007 },
  { "ctrl-h",		0x0008 },
  { "ctrl-i",		0x0009 },
  { "ctrl-j",		0x000a },
  { "ctrl-k",		0x000b },
  { "ctrl-l",		0x000c },
  { "ctrl-m",		0x000d },
  { "ctrl-n",		0x000e },
  { "ctrl-o",		0x000f },
  { "ctrl-p",		0x0010 },
  { "ctrl-q",		0x0011 },
  { "ctrl-r",		0x0012 },
  { "ctrl-s",		0x0013 },
  { "ctrl-t",		0x0014 },
  { "ctrl-u",		0x0015 },
  { "ctrl-v",		0x0016 },
  { "ctrl-w",		0x0017 },
  { "ctrl-x",		0x0018 },
  { "ctrl-y",		0x0019 },
  { "ctrl-z",		0x001a },
  { "alt-a",		0x1e00 },
  { "alt-b",		0x3000 },
  { "alt-c",		0x2e00 },
  { "alt-d",		0x2000 },
  { "alt-e",		0x1200 },
  { "alt-f",		0x2100 },
  { "alt-g",		0x2200 },
  { "alt-h",		0x2300 },
  { "alt-i",		0x1700 },
  { "alt-j",		0x2400 },
  { "alt-k",		0x2500 },
  { "alt-l",		0x2600 },
  { "alt-m",		0x3200 },
  { "alt-n",		0x3100 },
  { "alt-o",		0x1800 },
  { "alt-p",		0x1900 },
  { "alt-q",		0x1000 },
  { "alt-r",		0x1300 },
  { "alt-s",		0x1f00 },
  { "alt-t",		0x1400 },
  { "alt-u",		0x1600 },
  { "alt-v",		0x2f00 },
  { "alt-w",		0x1100 },
  { "alt-x",		0x2d00 },
  { "alt-y",		0x1500 },
  { "alt-z",		0x2c00 },
  { "insert",		0x5200 },
  { "home",		0x4700 },
  { "pageup",		0x4900 },
  { "delete",		0x5300 },
  { "end",		0x4f00 },
  { "pagedown",		0x5100 },
  { "leftarrow",	0x4b00 },
  { "rightarrow",	0x4d00 },
  { "uparrow",		0x4800 },
  { "downarrow",	0x5000 },
  { "alt-insert",	0xa200 },
  { "alt-home",		0x9700 },
  { "alt-pageup",	0x9900 },
  { "alt-delete",	0xa300 },
  { "alt-end",		0x9f00 },
  { "alt-pagedown",	0xa100 },
  { "alt-leftarrow",	0x9b00 },
  { "alt-rightarrow",	0x9d00 },
  { "alt-uparrow",	0x9800 },
  { "alt-downarrow",	0xa000 },
  { "shift-insert",	0x5200 },
  { "shift-home",	0x4700 },
  { "shift-pageup",	0x4900 },
  { "shift-delete",	0x5300 },
  { "shift-end",	0x4f00 },
  { "shift-pagedown",	0x5100 },
  { "shift-leftarrow",	0x4b00 },
  { "shift-rightarrow",	0x4d00 },
  { "shift-uparrow",	0x4800 },
  { "shift-downarrow",	0x5000 },
  { "ctrl-insert",	0x9200 },
  { "ctrl-home",	0x7700 },
  { "ctrl-pageup",	0x8400 },
  { "ctrl-delete",	0x9300 },
  { "ctrl-end",		0x7500 },
  { "ctrl-pagedown",	0x7600 },
  { "ctrl-leftarrow",	0x7300 },
  { "ctrl-rightarrow",	0x7400 },
  { "ctrl-uparrow",	0x8d00 },
  { "ctrl-downarrow",	0x9100 },
  { "enter",		0x000d },
  { "ctrl-enter",	0x000a },
  { "alt-enter",	0x1c00 }
};

int codeTableSize = sizeof( codeTable )/sizeof( KeyCode );
