#include <io.h>
#include <share.h>
#include <fcntl.h>
#include <time.h>
#include <errno.h>
#include <sys\stat.h>
#include <sys\types.h>

#include <process.h>
#define INCL_DOSSEMAPHORES
#include <os2.h>

#include "language.h"

#include "ea.h"
#include "misc.h"
#include "zinter.h"
#include "zdialog.h"
#include "filetype.h"
#include "rexxhook.h"
#include "session.h"
#include "freq.h"
#include "buffer.h"
#include "direct.h"

char *wasFileName = NULL;
static char *freqFileName = NULL;

/*
void addOneToBigNum( char *p )
{
  for( register char *q( p ); *p; p++ )
    if( *p==':' || *p=='/' || *p=='\\' || *p=='.' )
      q = p+1;

  if( !*q )
    return;

  p = q;
  q = q + strlen(q)-1;

  for( register int carry( 1 ); carry && q>=p; --q )
  {
    *q = char( *q+1 );

    switch( *q )
    {
    case 'Z'+1:
    case 'z'+1:
      *q = '0';
      break;

    case '9'+1:
      *q = 'A';

    // fall

    default:
      carry = 0;
      break;

    }
  }
}

int uniqueName( char *p )
{
  char *old = (char *)_alloca( strlen(p)+1 );

  strcpy( old, p );

  int rc( 0 );

  while( !access( p, 0 ) )
  {
    addOneToBigNum( p );
    rc = 1;

    if( !stricmp( old, p ) )
      break;
  }

  makeFileCase( p );
  return rc;
}
*/

void addOneToBigNum( char *p )
{
  for( register char *q( p ); *p; p++ )
    if( *p==':' || *p=='/' || *p=='\\' || *p=='.' )
      q = p+1;

  if( !*q )
    return;

  p = q; // p=file extansion part
  q = q + strlen(q)-1;

  for( register int carry( 1 ); carry && q>=p; --q )
  {
    *q = char( *q+1 );

    switch( *q )
    {
    case 'Z'+1:
    case 'z'+1:
      *q = '0';
      break;

    case '9'+1:
      *q = 'A';

    // fall

    default:
      carry = 0;
      break;

    }
  }
}

int uniqueName( char *p )
{
  char *old( tmpStr(p) );

  FileType ft( FileFile );      // changed by SZ: 뢠 ⨯ 䠩
  msgOfFileType( p, &ft );      // ।塞  (⨯)

  int rc( 0 );

  while( !access( p, 0 ) )
  {
// ᮡ⢥,    㦨  .  㬠 ⠪: 
// ᫨  બ  ᫨ ௠ ७,   
//  䠩,  ७   ??0
// ⮣    㤥 室  ⮬ 浪,     
//  .
//
// ᪮쪮  , ᮢ  .pkt 䠩 ᬠਢ
// ᫠   =) ,  ਭ樯, ⮦  㡠 -
// ७  騢 . ⮬ ᭮ ਪ ७.  
// ⠪, " । ᠬ࠭" () 쭨 稭  㡡.
//
//  ਭ樯,    ᥡ ਪ⨫ 7- ⨯ 䠩 FileType::FileTick. 
//  ᤥ   ⥡  ७ ⨪  襪  . 
//  -    樮쭮, ⮬    
// ,      ࠭. ᫨ 㬠  - 
//  2-3 㪢()   tic'  'zz',  ᭠砫 室 
// 䠩.

    switch( ft )
    {
    case FileMail:        // ᫨ 
      p[strlen(p)-4]='\0';
      addOneToBigNum( p );
      p[strlen(p)]='.';
      break;

    case FileXMail:       // ᫨ બ, 
      switch (p[strlen(p)-1])
      {
        case 'z':              // ᫨ 㦥  㪮䪨
        case 'Z':              //  ७  ௠, 
          p[strlen(p)-4]='\0'; // 㡠 ७ 䠩
          addOneToBigNum( p ); // 塞  䠩
          p[strlen(p)]='.';    //  ਪ ७  
          p[strlen(p)-1]='0';  // , , 뢠 稪 ७
          break;

        default:
          addOneToBigNum( p ); //   騢 ७
      }
      break;

    default:
      addOneToBigNum( p );     //   塞 ७.
    }

    rc = 1;

    if( !stricmp( old, p ) )
      break;
  }

  makeFileCase( p );
  return rc;
}

class Icon
{
public:
  FileType type;
  char *name;

  Icon( char *n, FileType t ) : type( t ), name( newStr( n ) ) {}
  ~Icon() { delete name; }
};

/*
void _Optlink setFileIcon( void *i )
{
  Icon *icon( (Icon *)i );
*/

void setICON( Icon *icon )
{
  char *iconFile;

  switch( icon->type )
  {
  case FileMail:
    iconFile = miscInfo.iconMail;
    break;

  case FileXMail:
    iconFile = miscInfo.iconXMail;
    break;

  case FileRIP:
    iconFile = miscInfo.iconRIP;
    break;

  default:
    iconFile = NULL;
    break;
  }

  if( iconFile!=NULL )
    setExtendedAttributeIcon( icon->name, iconFile );

  delete icon;
}

/*
void setICON( Icon *icon )
{
  int i = _beginthread( setFileIcon, 0, 40960, (void *)icon );

  if( i==-1 )
    log( Msg_ErrUnableStartIconThr, strError() );
}
*/

static char receivedFreq = 0;

void endRecoverUnlinkHR( char *fileName )
{
  if( !(miscInfo.state & BinkDRecover) || terminalActive )
    return;

  char *name( tmpStr( fileName ) );

  strcpy( name+strlen(name)-2, "hr" );
  forceDelete( name );
}

void endReceiveRecover( int ok )
{
  if( wasFileName==NULL )
  {
    log( Msg_RecNULLBUG );
    return;
  }

  char *arg( ok==OK ? "OK" : "FAIL" );

  log( "?endReceiveRecover: REXX hook ask %s `%s'", arg, Filename );

  char yourself( 1 );
  char *hook( processRexxHook( "RecoverFile", arg, Filename, NULL,
                               NULL, NULL, NULL, 1 ) );

  if( hook!=NULL )
  {
    if( stricmp( hook, "Forget" ) )
    {
      FileType type;
      FileType type1;
      char *who = msgOfFileType( Filename, &type, &type1 );

      log( "?endReceiveRecover: REXX hook say FORGET" );
      log( Msg_InfoDeletePartial, Filename, who );

      if( unlink( Filename ) )
        log( Msg_ErrUnableDelete, Filename, strError() );

      endRecoverUnlinkHR( Filename );

      yourself = 0;
    }
    else if( stricmp( hook, "YourSelf" ) )
      log( "?endReceiveRecover: REXX hook say YOURSELF" );
    else
      log( Msg_ErrIllegalRecoverFileMode, hook );

    delete hook;
  }

  if( yourself )
    if( ok==OK )
    {
      log( "?endReceiveRecover: started with OK" );

      char *oriFileNameForEA = tmpStr( fileName( wasFileName ) );

      if( uniqueName( wasFileName ) )
        log( Msg_RecDuplicate, wasFileName );

      makeFilePath( wasFileName );

      if( rename( Filename, wasFileName ) )
        log( Msg_ErrUnableRename, Filename, wasFileName, strError() );
      else
      {
        endRecoverUnlinkHR( Filename );

        char *t( strTime( time( NULL ), 1 ) ),
             subj[256];

        if( terminalActive )
          strcpy( subj, Msg_EAReceivedTerminal );
        if( primaryAka!=NULL )
        {
          char bb[65];

          sprintf( subj, Msg_EAReceivedFrom,
                   primaryAka->toString( bb, sizeof(bb)-1 ) );
        }
        else
          strcpy( subj, Msg_EAReceivedREXX );

        FileType fileType;
        FileType fileType1;
        char *who = msgOfFileType( oriFileNameForEA, &fileType, &fileType1 );

        who = tmpStr( who );
        capitalize( who );

        setExtendedAttribute( wasFileName, ".TYPE", who );
        setExtendedAttribute( wasFileName, ".HISTORY", t );
        setExtendedAttribute( wasFileName, ".COMMENTS", subj );
        setExtendedAttribute( wasFileName, ".SUBJECT", Msg_EANetFile );
        setICON( new Icon( wasFileName, fileType1 ) );

        delete t;

        setFileStamp( wasFileName, filetime, 1 );
      }

      if( receivedFreq )
        processFreq( freqFileName );
    }
    else
    {
      log( "?endReceiveRecover: started with FAIL" );

      struct stat st;

      if( !stat( Filename, &st ) && !st.st_size )
      {
        log( Msg_InfoEmptyFile, Filename );

        forceDelete( Filename );
        endRecoverUnlinkHR( Filename );
      }
      else
      {
        FileType type;
        FileType type1;
        char *who = msgOfFileType( wasFileName, &type, &type1 );

        if( (type==FileMail && (miscInfo.state1&DiscardPKT)==DiscardPKT) ||
  	    type==FileReq )
        {
          log( Msg_InfoDeletePartial, Filename, who );

          if( unlink( Filename ) )
            log( Msg_ErrUnableDelete, Filename, strError() );

          endRecoverUnlinkHR( Filename );
        }
        else
        {
          char *t( strTime( time( NULL ), 1 ) ),
               subj[256];

          if( terminalActive )
            strcpy( subj, Msg_EAReceivedTerminalInc );

          if( primaryAka!=NULL )
          {
            char bb[65];

            sprintf( subj, Msg_EAReceivedFromInc,
                     primaryAka->toString( bb, sizeof(bb)-1 ) );
          }
          else
            strcpy( subj, Msg_EAReceivedREXXInc );

          who = tmpStr( who );
          capitalize( who );

          setExtendedAttribute( Filename, ".TYPE", who );
          setExtendedAttribute( Filename, ".HISTORY", t );
          setExtendedAttribute( Filename, ".COMMENTS", subj );
          setExtendedAttribute( Filename, ".SUBJECT", Msg_EANetFile );
          setICON( new Icon( Filename, type1 ) );

          delete t;

          setFileStamp( Filename, filetime, 1 );
        }
      }
    }

  strcpy( Filename, wasFileName );
  delete wasFileName;
  wasFileName = NULL;
}

int inline isInvalid( unsigned char c )
{
  return (c==0x7f || c<=0x20 ||
          c=='"'  || c=='*'  || c=='<' ||
          c=='>'  || c=='?'  || c=='|' ) ? 1 : 0;
}

class BinkdHR
{
  Buffer buf;
  int ok;

public:
  BinkdHR( char *name, char *path );

  int itsMe( char *rname, unsigned long file_length, unsigned long filetime,
             char *paka );
};

BinkdHR::BinkdHR( char *name, char *path ) :
  ok( 1 ),
  buf( 128 )
{
  char *fileName( (char *)_alloca( strlen(name)+strlen(path)+2 ) );

  strcpy( fileName, name );

  if( fileName[ strlen(fileName)-1 ] != '\\' )
    strcat( fileName, "\\" );

  strcat( fileName, path );

  FILE *dt( fopen( fileName, "r" ) );

  if( dt==NULL )
  {
    ok = 0;
    log( Msg_ErrUnableOpen, fileName, strError() );
    return;
  }

  while( 1 )
  {
    int ch( fgetc( dt ) );

    if( ch==EOF || ch=='\n' )
      break;

    buf.putInto( char( ch ) );
  }

  buf.putInto( 0 );

  if( ferror( dt ) )
  {
    ok = 0;
    log( Msg_ErrUnableRead, fileName, strError() );
  }
  else
  {
    buf.deQuote();
    strlwr( buf.str );
  }

  fclose( dt );
}

int BinkdHR::itsMe( char *rname, unsigned long file_length,
                    unsigned long filetime, char *paka )
{
  if( !ok )
    return 0;

  Buffer bbb( 128 );
  char patt[ 16 ];

  bbb.putQuotted( rname );
  bbb.putInto( ' ' );
  sprintf( patt, "%lu", file_length );
  bbb.putString( patt );
  bbb.putInto( ' ' );
  sprintf( patt, "%lu", filetime );
  bbb.putString( patt );
  bbb.putInto( ' ' );
  bbb.putString( paka );
  bbb.putInto( 0 );

  strlwr( bbb.str );

  if( buf.length() != bbb.length() )
    return 0;

  return memcmp( buf.str, bbb.str, buf.length() ) == 0 ? 1 : 0;
}

int startReceiveRecover( byte **mode )
{
  log( "?startReceiveRecover started" );

  delete realname;
  realname = new char [ strlen(Filename)+_MAX_PATH ];
  strcpy( realname, Filename );

  receivedFreq = 0;

  char sizeStr[32],
       timeStr[32];

  sprintf( sizeStr, "%lu", file_length );
  sprintf( timeStr, "%lu", filetime );

  char *hook( processRexxHook( "RecoverFile", "QUERY", Filename, sizeStr,
                                              timeStr, NULL, NULL, 1 ) );
  FileType type;

  if( hook!=NULL && stricmp( hook, "YourSelf" ) )
  {
    char *bl = strchr( hook, ' ' );

    if( bl==NULL )
Fail:
      log( Msg_ErrIllegalRecoverFileMode, hook );
    else
    {
      *bl=0;
      strcpy( Filename, bl+1 );
      delete realname;
      realname = new char [ strlen(Filename)+_MAX_PATH ];
      strcpy( realname, Filename );
      log( "?startReceiveRecover: REXX hook ask QUERY `%s'", Filename );

      if( !stricmp( hook, "Yes" ) )
      {
        log( "?startReceiveRecover: REXX hook say RECOVER" );
        *mode = (byte *)"r+b";
        goto HookReceive;
      }
      else if( !stricmp( hook, "No" ) )
      {
        log( "?startReceiveRecover: REXX hook say DON`T RECOVER" );
        *mode = (byte *)"w+b";

HookReceive:
        msgOfFileType( Filename, &type );

        if( type==FileReq )
        {
          delete freqFileName;
          freqFileName = newStr( Filename );
          receivedFreq = 1;
        }

        delete hook;
        return OK;
      }
      else if( !stricmp( hook, "Skip" ) )
      {
        log( "?startReceiveRecover: REXX hook say PLEASE SKIP" );
        delete hook;
        log( Msg_InfoSkipHim, Filename );
        return ZSKIP;
      }
      else if( !stricmp( hook, "Error" ) )
      {
        log( "?startReceiveRecover: REXX hook say UNABLE RECEIVE" );
        delete hook;
        log( Msg_InfoUnableReceive, Filename );
        return ERROR;
      }
      else
	goto Fail;
    }
  }

  delete hook;

  msgOfFileType( Filename, &type );

  if( type==FileReq )
  {
    char *p1 = fileName( Filename );
    char skip( 1 ),
	 buf[12];

    if( (miscInfo.state3&CheckREQ)==CheckREQ )
      for( FIDOAddressIterator list( *systemInfo.addr ); skip && list; list++ )
      {
        FIDOAddress& cur = list();

        if( cur.getPoint() )
        {
	  sprintf( buf, "%08lx", (unsigned long)cur.getPoint() );
          skip = char( !begin( p1, buf ) );

          if( skip )
            goto check_as_node;
        }
        else
        {
check_as_node:
	  sprintf( buf, "%04x%04x", int( cur.getNet()&0xffff ),
	  	   int( cur.getNode()&0xffff ) );
          skip = char( !begin( p1, buf ) );
        }
      }
    else
      skip = 0;

    if( skip )
    {
      log( Msg_RecBaseFREQIll, p1 );
      return ZSKIP;
    }

    for( long seq(0); seq>=0; seq++ )
    {
      sprintf( p1, "%04lx%04lx.req", seq, (long)miscInfo.taskNumber );

      if( access( Filename, 0 ) )
        break;
    }

    if( seq<0 )
    {
      log( Msg_RecBaseUnableFREQ );
      return ZSKIP;
    }

    makeFileCase( Filename );
    delete realname;
    realname = new char [ strlen(Filename)+_MAX_PATH ];
    strcpy( realname, Filename );
    log( "?startReceiveRecover: .req received as `%s'", Filename );
    delete freqFileName;
    freqFileName = newStr( Filename );
    receivedFreq = 1;
  }

  if( (miscInfo.state3&CheckName)==CheckName )
  {
    char was(0);

    for( register char *p( Filename ); *p; p++ )
      if( isInvalid(*p) )
      {
         was = 1;
         *p = '_';
      }

    for( p=realname; *p; p++ )
      if( isInvalid(*p) )
      {
         was = 1;
         *p = '_';
      }

    if( was )
      log( "?startReceiveRecover: illegal chars in file name was changed with '_'" );
  }

  *mode = (byte *)"w+b";

  Resume_WaZOO = 0;

  delete wasFileName;
  wasFileName = newStr( Filename );

  struct stat st;

  if( !stat( wasFileName, &st ) &&
      st.st_mtime-getTimeZone()==filetime &&
      st.st_size==file_length )
  {
    log( Msg_InfoSkipHim, wasFileName );
    return ZSKIP;
  }

  if( !(miscInfo.state & BinkDRecover) || terminalActive )
  {
    log( "?startReceiveRecover: classic inbound%s", terminalActive ? " (terminal)" : "" );

    char tempDir[]( "Recover\\" ),
         drive[_MAX_DRIVE],
         dir  [_MAX_DIR+sizeof(tempDir)],
         file [_MAX_FNAME],
         ext  [_MAX_EXT];

    _splitpath( Filename, drive, dir, file, ext );
    strcat( dir, tempDir );
    _makepath( Filename, drive, dir, file, ext );

    if( !stat( Filename, &st ) )
    {
      if( st.st_mtime-getTimeZone()==filetime )
      {
        log( "?startReceiveRecover: resuming" );

        Resume_WaZOO = 1;
        *mode = (byte *)"r+b";
      }
      else
        log( "?startReceiveRecover: overwrite incomplete" );

      return OK;
    }
  }
  else
  {
    char drive[_MAX_DRIVE],
         dir  [_MAX_DIR],
         file [_MAX_FNAME],
         ext  [_MAX_EXT],
         patt [_MAX_PATH],
         rname[_MAX_PATH],
         paka [1024];

    primaryAka->toString( paka, (sizeof paka)-1, FIDOAddressShowModeEMSI );

    _splitpath( Filename, drive, dir, file, ext );

    strcpy( rname, file );
    strcat( rname, ext );

    strcpy( file, "*" );
    strcpy( ext, ".hr" );

    _makepath( patt, drive, dir, file, ext );

    log( "?startReceiveRecover: search binkd inbound for %s in %s", rname, patt );

    for( Directory rc( patt ); rc; rc++ )
    {
      log( "?startReceiveRecover: found - %s", rc.getName() );

      BinkdHR hr( rc.getPath(), rc.getName() );

      if( hr.itsMe( rname, file_length, filetime, paka ) )
      {
        char *fname( tmpStr( rc.getName() ) );

        Resume_WaZOO = 1;
        *mode = (byte *)"r+b";

        fname[ strlen(fname)-3 ] = 0;
       _makepath( Filename, drive, dir, fname, ".dt" );

        log( "?startReceiveRecover: resuming to %s", fileName( Filename ) );
        return OK;
      }
    }

    Buffer buf( 128 );

    sprintf( patt, " %lu %lu %lu ", file_length, filetime, time( NULL ) );
    buf.putQuotted( rname );
    buf.putQuotted( patt );
    buf.putQuotted( paka );
    buf.putInto( 0 );

    unsigned long cur( CRC32POST( crc32block( hCrc32Tab, CRC32INIT,
                                              (unsigned char *)buf.str,
                                              strlen( buf.str ) ) ) ),
                  limit( cur );

    buf.reset();
    buf.putQuotted( rname );
    buf.putInto( ' ' );
    sprintf( patt, "%lu", file_length );
    buf.putString( patt );
    buf.putInto( ' ' );
    sprintf( patt, "%lu", filetime );
    buf.putString( patt );
    buf.putInto( ' ' );
    buf.putString( paka );

    while( 1 )
    {
      char fname[9];

      sprintf( fname, "%08x", cur );
      _makepath( Filename, drive, dir, fname, ".hr" );

      makeFilePath( Filename );

      int h( _sopen( Filename, O_CREAT|O_EXCL|O_WRONLY|O_TEXT,
                     SH_DENYRW,
                     S_IREAD|S_IWRITE ) );

      if( h==-1 )
      {
        if( errno!=EEXIST )
        {
          log( Msg_ErrUnableCreate, Filename, strError() );
          return ZSKIP;
        }

        cur++;

        if( cur==limit )
        {
          log( Msg_ErrUnableReceiveDTHR, wasFileName, strError() );
          return ZSKIP;
        }
      }
      else
      {
        if( write( h, buf.str, buf.length() ) != buf.length() )
        {
          log( Msg_ErrUnableWrite, Filename, strError() );
          close( h );
          return ZSKIP;
        }

        _makepath( Filename, drive, dir, fname, ".dt" );
        close( h );
        break;
      }
    }
  }

  log( "?startReceiveRecover: new file" );
  return OK;
}