#include "regexp.h"

RegularExpresion::RegularExpresion( char *str ) :
  errMsg( 0 )
{
  err = regcomp( &mask, str, REG_EXTENDED|REG_NOSUB );
}

RegularExpresion::~RegularExpresion()
{
  regfree( &mask );
  delete errMsg;
}

char *RegularExpresion::getRegErrorMsg()
{
  if( !errMsg )
    errMsg = new char [1024];

  regerror( err, &mask, errMsg, 1024 );
  return errMsg;
}

int RegularExpresion::maskMach( char *addr )
{
  if( err )
    return 0;

  return !regexec( &mask, addr, 0, 0, 0 );
}
