#include <process.h>
#include <time.h>
#include <stdio.h>
#include <io.h>
#include <share.h>
#include <string.h>
#include <builtin.h>

#define INCL_DOSPROCESS
#define INCL_DOSEXCEPTIONS
#include <os2.h>

#include "except.h"

#include "language.h"

#include "misc.h"
#include "32base.h"
#include "direct.h"

void processTryFile( char *full, char *name, int& count )
{
  char *unl = (char *)_alloca( strlen(full)+strlen(name)+1 );

  strcpy( unl, full );
  strcat( unl, name );
  capitalize( unl );

  if( !forceDelete( unl ) )
    count++;
}

void processPoint( char *fullPath, char *nodePath, int& count )
{
  char *mask( "\\*.Sta" ),
       *path = (char *)_alloca( strlen(fullPath)+strlen(nodePath)+strlen( mask )+1 ),
       *full = (char *)_alloca( strlen(fullPath)+strlen(nodePath)+2 );

  strcpy( path, fullPath );
  strcat( path, nodePath );
  strcat( path, mask );

  strcpy( full, fullPath );
  strcat( full, nodePath );
  strcat( full, "\\" );

  for( Directory rc( path ); rc; rc++ )
  {
    uShort point( 0 ), fict( 0 );
    char *name = rc.getName();

    if( strlen( name )==12 && split16base( name, fict, point ) )
      processTryFile( full, name, count );
  }
}

void processZone( int outLen, char *zoneStr, int& count, Domain *dom )
{
  uShort zone( 0 );
  char ext[_MAX_EXT];

  {                            //  ᪮ ᯮ짮 fnsplit
    char drive[_MAX_DRIVE],
	 dir[_MAX_DIR],
	 file[_MAX_FNAME];

    _splitpath( zoneStr, drive, dir, file, ext );

    if( *ext )
    {
      if( val16base( ext+1, zone ) )
	return;
    }
    else
      zone = dom->getDefZone();
  }

  char mask[]( "\\*" ),
    *path = (char *)_alloca( outLen+strlen(ext)+sizeof( mask ) ),
    *full = (char *)_alloca( outLen+strlen(ext)+20 ),
    *outbound( dom->getOutbound() );

  strcpy( path, outbound );
  strcpy( path+outLen-1, ext );
  strcat( path, mask );

  strcpy( full, outbound );
  strcpy( full+outLen-1, ext );
  strcat( full, "\\" );

  for( Directory rc( path,
                     SearchAttributes( MayBeDirectory|MayBeReadOnly|MayBeArchived ) );
                 rc; rc++ )
  {
    char *name = rc.getName();
    uShort net( 0 ), node( 0 );

    if( strlen( name )==12 && split16base( name, net, node ) )
      if( (rc.getAttrib()&MayBeDirectory)==MayBeDirectory &&
          !stricmp( name+8, ".pnt" ) )
	processPoint( full, name, count );
      else
	if( !stricmp( name+8, ".Sta" ) )
	  processTryFile( full, name, count );
  }

  delete outbound;
}

void processLong( int& count )
{
  static char mask[]( "*.Status" );
  char *full( (char *)_alloca( strlen(miscInfo.longOutbound)+sizeof(mask) ) );

  strcpy( full, miscInfo.longOutbound );
  strcat( full, mask );

  for( Directory rc( full, SearchAttributes( MayBeReadOnly|MayBeArchived ) );
      rc; rc++ )
  {
    char *name( newStr( rc.getName() ) );
    uShort zone, net, node, point;
    char *domain;
    LongNameType type;
    Flavour fl;

    if( splitLongName( name, zone, net, node, point, &domain, fl, type ) &&
        type==tryLongName )
      processTryFile( miscInfo.longOutbound, rc.getName(), count );

    delete name;
  }
}

void _Optlink doReset( void * )
{
  registerExceptionHandler

  DosSetPriority( PRTYS_THREAD, 0, -miscInfo.priorityDelta, 0 );

  unsigned long start( getTimeMark() );
  int count( 0 );

  if( miscInfo.longOutbound )
    processLong( count );

  static char mask[]( ".*" );

  for( DomainIterator list( *outboundInfo.domains ); list; list++ )
  {
    Domain *dom = &list();
    char *outbound( dom->getOutbound() );
    int outLen( strlen(outbound) );
    char *path( new char[ outLen+sizeof(mask) ] );

    strcpy( path, outbound );
    strcpy( path+outLen-1, mask );

    for( Directory rc( path,
                       SearchAttributes( MustBeDirectory|MayBeReadOnly|MayBeArchived ) );
                   rc; rc++ )
    {
      char *name = rc.getName();

      if( (rc.getAttrib()&MayBeDirectory)==MayBeDirectory )
        if( strcmp( name, "." ) && strcmp( name, ".." ) )
	  processZone( outLen, name, count, dom );
    }

    delete outbound;
    delete path;
  }

  if( count )
  {
    start = getTimeMark() - start;
    log( Msg_InfoResetTryStat, start/60, start%60, count );
  }

  deRegisterExceptionHandler
}

void resetTry()
{
  long ttt = _beginthread( doReset, 0, 40960, 0 );

  if( ttt==-1 )
    log( Msg_ErrTryCountThr, strError() );
  else
    log( Msg_ThrTryCountThr, ttt );
}
