#include "timeout.h"

TimeOut::TimeOut( long _s, int _t ) :
  speed( _s ),
  timeOut( _t )
{}

int TimeOut::equal( const BaseObject &t ) const
{
  return speed == (*(const TimeOut *)&t).speed;
}

void TimeOut::print( ostream& s ) const
{ 
  s << "Speed:" << speed << ",Value:" << timeOut;
}

char *TimeOut::nameOfClass() const
{
  return "TimeOut";
}

TimeOutList::TimeOutList() :
  Collection( 5, 5, SemaphoreModeNoNeed )
{
}

TimeOut* TimeOutList::Find( TimeOut& item, LockMode lock ) const
{
  return (TimeOut*)Collection::Find( item, lock );
}
    
TimeOut& TimeOutList::operator [] ( const int pos ) const
{
  return *(TimeOut *)&(Collection::operator[]( pos ));
}

TimeOutIterator::TimeOutIterator( TimeOutList& ini ) :
  CollectionIterator( *(Collection *)&ini )
{
}

TimeOut& TimeOutIterator::operator () () const
{
  return *(TimeOut *)&(CollectionIterator::operator()());
}