#if !defined(__TRANSLATION_H)

#define __TRANSLATION_H

#include "class.h"

class TransItem : public BaseObject
{
private:
  char *pref, *as, *suf;
  int cost;

  int equal( const BaseObject &t ) const;
  void print( ostream& s ) const;
  char *nameOfClass() const;

public:

  TransItem( char *ip, char *ia, char *is=0, int cs=0 );
  ~TransItem();

  char *getTranslate() const { return as; }
  char *getPreffix() const { return pref; }
  char *getSuffix() const { return suf; }
  int getCost() const { return cost; }
};

class TranslationTable : public Collection		//TransItem
{
private:
  char *countryCode,
       *internationalCall,
       *localCode;

  void freePvt();

public:
  TranslationTable();
  ~TranslationTable();

  TransItem* Find( TransItem& item, LockMode lock=LockModeNeed ) const;
  TransItem& operator [] ( const int pos ) const;

  friend ostream& operator << ( ostream& o, const TranslationTable& c );

  void append( char *pref, char *as, char *suf, int cost );

  char *getCountry()       const { return countryCode; }
  char *getInternational() const { return internationalCall; }
  char *getLocal()         const { return localCode; }
  
  void setCountry( char *code, char *call, char *l );

  void translate( char *who, char **rez);
  static char *construct( char*, char*, char*, char* ); 

  int findCost( char *phone );
};

class TranslationIterator : public CollectionIterator		//TransItem
{
public:
  TranslationIterator( TranslationTable& ini );

  TransItem& operator () () const;
};

extern TranslationTable *translationTable;

#endif