#define INCL_VIO
#define INCL_DOS
#include <os2.h>

#include <memory.h>

#include "vio.h"

#include "language.h"
#include "misc.h"

static VIOMODEINFO vio;

void VioScreenDisable( void )
{
  vio.cb = sizeof(vio);
  VioGetMode( &vio, 0 );

  VioScreenEnabled = 0;
}

void VioScreenEnable( void )
{
  vio.cb = 8;
  VioSetMode( &vio, 0 );

  VioScreenEnabled = 1;

  if( VioScreenHolded )
    VioVisualizeScreen();
}

int VioSystemScreen( int x, int y )
{
  int i, j;

  VioScreenWidth = x;
  VioScreenSize = x*y;

  if( VioScreen!=NULL )
    delete VioScreen;

  VioScreen = new USHORT [VioScreenSize];

  for( i=0; i<x; i++ )
    for( j=0; j<y; j++ )
      VioScreen[ j*x+i ] = 0x0732;

  return 0;
}

int InitVioSystem( void )
{
  char errBuf[80] = {0};
  HMODULE h;

  APIRET rc = DosLoadModule( errBuf, sizeof(errBuf), "VIOCALLS", &h );

  if( rc )
  {
    log( Msg_ErrVioNotLoad, *errBuf ? " -> " : "", errBuf, rc );
    os2Message( rc );
    return int( rc );
  }

  rc = DosQueryProcAddr( h, 0, "VIOWRTCELLSTR", (PFN *)&VioWrite );

  if( rc )
  {
    log( Msg_ErrVioNotFound, rc );
    os2Message( rc );
    return int( rc );
  }

  return 0;
}
