#define INCL_VIO
#define INCL_DOSDATETIME
#include <os2.h>

#include <memory.h>
#include <malloc.h>

#include "vio.h"

APIRET16 (* APIENTRY16 VioWrite)( PCH CellStr, USHORT Length,
                                  USHORT Row, USHORT Column,
                                  HVIO VioHandle );

USHORT *VioScreen = NULL;
volatile char VioScreenHolded = 0;
volatile char VioScreenEnabled = 1;
volatile char VioScreenSaverActive = 0;
int VioScreenSize = 0;
int VioScreenWidth = 0;

int VioVisualizeScreen( void )
{
  VioScreenHolded = 0;
  return (*VioWrite)( (PCH)(void *)VioScreen, VioScreenSize*sizeof(USHORT), 0, 0, 0 );
}

static APIRET16 reverse( HVIO VioHandle )
{
  int i = 0;
  APIRET16 rc = 0;
  USHORT *newBuf = (USHORT *)malloc( VioScreenSize*sizeof(USHORT) );

  if( newBuf==NULL )
    return 0;

  for( i=0; i<VioScreenSize; i++ )
    newBuf[ i ] = VioScreen[ VioScreenSize-i-1 ];

  rc = VioWrite( (PCH)(void *)newBuf, VioScreenSize*sizeof(USHORT), 0, 0, VioHandle );
  free( newBuf );
  return rc;
}

APIRET16 APIENTRY16 VIO16WRTCELLSTR( PCH CellStr, USHORT Length,
                                     USHORT Row, USHORT Column,
                                     HVIO VioHandle )
{
  static int reversed = 0;
  APIRET16 rc = 0;

  if( Row*Column>=VioScreenSize )
    return 0;

  if( VioScreen!=NULL )
  {
    int pos = Row*VioScreenWidth + Column;
    int len = Length;
    DATETIME dt = {0,0,0,0,0,0,0,0,0};
    ULONG current = 0;

    if( pos*sizeof(USHORT)+Length>VioScreenSize*sizeof(USHORT) )
      len = (VioScreenSize-pos)*sizeof(USHORT);

    if( len>0 )
      memcpy( VioScreen+pos, CellStr, len );

    DosGetDateTime( &dt );
    current = (((dt.day-1)*24+dt.hours)*60+dt.minutes)*60+dt.seconds;
  
    if( reversed )
    {
      if( reversed+10<=current )
      {
        reversed = 0;
        VioVisualizeScreen();
      }
    }
    else if( dt.month==4 && dt.day==1 && !dt.seconds && !dt.minutes && dt.hours )
      reversed = current;
  }

  if( VioScreenEnabled && !VioScreenSaverActive )
    if( VioScreenHolded )
      rc = VioVisualizeScreen();
    else
      if( !reversed )
        rc = VioWrite( CellStr, Length, Row, Column, VioHandle );
      else
        rc = reverse( VioHandle );
  else
    VioScreenHolded = 1;

  return rc;
}
