#include "winhand.h"

WindowHandle::WindowHandle( Window *w ) :
  win( w )
{
}

WindowHandle::~WindowHandle()
{
  delete win;
}

int WindowHandle::equal( const BaseObject &t ) const
{
  return win == (*(const WindowHandle *)&t).win;
}

void WindowHandle::print( ostream& s ) const
{
}

char *WindowHandle::nameOfClass() const
{
  return "WindowHandle";
}

void WindowHandle::setWindow( Window *_win )
{
  win = _win;
}

WindowHandleList::WindowHandleList() :
  Collection( 5, 5, SemaphoreModeNeed )
{
}

WindowHandle* WindowHandleList::Find( WindowHandle& item, LockMode lock ) const
{
  return (WindowHandle*)Collection::Find( item, lock );
}
    
WindowHandle& WindowHandleList::operator [] ( const int pos ) const
{
  return *(WindowHandle *)&(Collection::operator[]( pos ));
}

WindowHandleIterator::WindowHandleIterator( WindowHandleList& ini ) :
  CollectionIterator( *(Collection *)&ini )
{
}

WindowHandle& WindowHandleIterator::operator () () const
{
  return *(WindowHandle *)&(CollectionIterator::operator()());
}
