#if !defined(__WORK_TIME)

#define __WORK_TIME

#include "class.h"

typedef unsigned short uShort;
typedef unsigned char uChar;
typedef unsigned long uLong;

class WorkTime : public BaseObject
{
  uChar mask[7][24*60/8];
  char *wtStr;
  char valid;
  char isGmt;

  int equal( const BaseObject &t ) const;
  void print( ostream& s ) const;
  char *nameOfClass() const;

  void initNDL( const char *s );
  void initSubst( const char *s );

  void markInterval( int wFrom, int wTo, int from, int to );
  void mark( int dayOfWeek, int hour, int halfHour );

protected:

  int makeIndex( int hour, int mins ) const;

public:

  WorkTime( const char *s );
  WorkTime( WorkTime *w );
  WorkTime( WorkTime & );
  void init( const char *s );

  ~WorkTime();

  int isWorked( uLong stamp=0 ) const;
  int isValid() const { return valid; }
  int isPresent() const { return wtStr!=NULL; }
  char *getStr() const { return wtStr; }
};

char *stringWorkTime( WorkTime *wt, char *buf, int len );

#endif