#if !defined( _ZMODEM_H )

#define _ZMODEM_H

#include <stdio.h>

#include "rcvdlist.h"

#define Zmodem   0
#define ZedZap   1
#define DirZap   2
#define HydraSes 3

/*--------------------------------------------------------------------------*/
/* Parameters for calling ZMODEM routines                                   */
/*--------------------------------------------------------------------------*/
#define SPEC_COND       2
#define VERY_SPEC_COND  3
#define TRUE            1
#define FALSE           0
#define END_BATCH       (-1)
#define NOTHING_TO_DO   (-2)
#define DELETE_AFTER    '-'
#define TRUNC_AFTER     '#'
#define NOTHING_AFTER   '@'
#define DO_WAZOO        TRUE
#define DONT_WAZOO      FALSE

#define OK              0
#define ERROR           (-1)
#define TIMEOUT         (-2)
#define RCDO            (-3)
#define FUBAR           (-4)
#define ERROR_ABORT     (-5)
#define USER_ABORT      (-6)
#define USER_SKIP       (-7)

struct ZModemRexxCallBackContext
{
  char *name;
  int count;
};

typedef void (*CallBackFunc)( ZModemRexxCallBackContext *context, char *nameFile );

int Send_Zmodem( char *fname, char *alias, int fsent,
                 int wazoo, int trunc, FILE *xferinfo );
int Get_Zmodem( char *rcvpath, ReceivedFileList& xferinfo,
                int wazoo, int needSkip=0 );
char *isProtocol( int );
char *isProtocolShort( int );
int ZSend_Batch( char *, int, CallBackFunc =0, ZModemRexxCallBackContext* =0 );

extern long zInCount,
	    zOutCount,
	    zInBytes,
	    zOutBytes,
	    zTransStart,
	    zRecStart;

extern int zSendInitBlock;
extern int sesCpsMinimum;

#endif
