/************************ SWin ***************************\
 *
 *	Copyright (C) 1996 by Dmitry Zavalishin
 *
 *	Module 	: map classes
 *
 *      $Log: sw_map.h $
 *      Revision 1.2  1996/09/27 00:33:20  dz
 *      viobuf, optimization (sort of:)
 *
 *      Revision 1.1  1996/09/12 01:12:51  dz
 *      Initial revision
 *
 *
 *      
 *
\*/

#ifndef MAP_H
#define MAP_H

//#include "vector.h"
#include "sw_types.h"


class sw_abstract_win;

class sw_map : public sw_size
    {
    private:
        sw_abstract_win **v;
        
        void allocme();
        void freeme();
    public:
        sw_map( const sw_size &s );
        ~sw_map();
        
        virtual void xs( int _ );
        virtual void ys( int _ );
        virtual void resize( const sw_size &s );
        
        void clear( sw_abstract_win * );
        void load( const sw_map &m, const sw_point &p );

        int  belongs( const sw_abstract_win *win, int x, int y ) const;
        int  belong_count( const sw_abstract_win *win, int x, int y ) const;
        int  not_belong_count( const sw_abstract_win *win, int x, int y ) const;

        void dump() const;

        const sw_abstract_win * const * mapp() const { return v; }
    };




#endif // MAP_H


