#include "misc.h"

ostream& operator << ( ostream& o, const Modem& c )
{
  o << "  Speed    " << c.speed << " [";

  register long sp( 150 );

  switch( c.speed )
  {
  case B57600:
    sp =  57600;
    break;

  case B115200:
    sp =  115200;
    break;

  case B230400:
    sp =  230400;
    break;

  case B345600:
    sp =  345600;
    break;

  case B76800:
    sp <<= 1;
  case B38400:
    sp <<= 1;
  case B19200:
    sp <<= 1;
  case B9600:
    sp <<= 1;
  case B4800:
    sp <<= 1;
  case B2400:
    sp <<= 1;
  case B1200:
    sp <<= 1;
  case B600:
    sp <<= 1;
  case B300:
    sp <<= 1;
    break;
  }

  if( sp==150 )
    o << "*who known*";
  else
    o << sp;

	o << char(']');

  o << endl
    << "  Port     " << c.portNumber << endl
    << "  State    " << c.state << endl
    << "  HardFlow " << (c.hardWare ? "On" : "Off") << endl
    << "  Break    " << (c.breakMode ? "On" : "Off") << endl
    << "  Fail     " << c.failSafe << endl
    << "  Monitor  " << c.carrierMonitor << endl
    << "  Block    " << (c.blockMode ? "On" : "Off") << endl;

  o << "  Init     `";
  strItem( o, c.initStr );
  o  << "'\n";

  o << "  OffHook  `";
  strItem( o,  c.offHookStr );
  o << "'\n";

  o << "  Answer   `";
  strItem( o, c.answerStr );
  o << "'\n";

  o << "  DialPref `";
  strItem( o, c.dialPref );
  o << "'\n";

  o << "  DialSuf  `";
  strItem( o, c.dialSuff );
  o << "'\n";

  o << "  DialAft  `";
  strItem( o, c.afterDial );
  o << "'\n";

  o << "  OnExit   `";
  strItem( o, c.onExit );
  o << "'\n";

  o << "  CallWait " << c.callWait << endl
    << "  AnswWait " << c.answerWait << endl
    << "  Pause    " << c.pause << endl
    << "  ActSpeed " << c.actualSpeed << endl;

  o << "  ActSuff  ";
  if( c.connectSuff==NULL )
    o << "<NULL>";
  else
  {
    o << char('`');
    strItem( o, c.connectSuff );
    o << char('\'');
  }

  return o;
}
