#if defined(__OS2__)
#  define Cdecl
#else
#  define Cdecl cdecl
#endif

#ifdef __EMX__
#include "emx.h"		// gcc/emx compiler
#endif

#include "regexp.h"
extern regexp *nodeMask;

#include "mtask.h"

typedef unsigned long big;
typedef unsigned short index;

const unsigned short MaxItems = 0xffff/sizeof(void *);
extern int completeCode;

// Current statistics

struct InfoStr
{
  big dial, answer, income, outcome, external, bbs, terminal;
  unsigned short usedCount;
};

extern InfoStr info[48];

struct NodeInfo
{
  char *domain;
  unsigned short zone, net, node, point;
  big ioTime;
  big sent, received;
  big income, outcome, inSession, outSession;
  big bbs;
  big inMail, inXmail, inFiles,
      outMail, outXmail, outFiles;
};

extern NodeInfo **nodesInfo;
extern index totalNodes;

struct IOInfo
{
  char *name;
  big count, total;
};

extern IOInfo **ioInfo;
extern index totalIO;

extern big inSessions, outSessions,
           inHand, outHand,
           startTime, endTime,
           totalDialing, totalAnswering,
           totalIncome, totalOutcome,
           totalExternal,
           totalBBS,
           totalTerminal,
           totalBytesIn, totalBytesOut,
           inMail, inXmail, inFiles,
           outMail, outXmail, outFiles,
           sesFTS0001, sesWaZOO, sesEMSI, sesXZ;

// LOG parser declaration

enum LOGStyle { logUnknownStyle=0, logBinkStyle, logTMStyle, logBrakeStyle };

enum SessionType { WhoKnown = 0, FTS0001, WaZOO, EMSI };

enum FileType { Undefined=0, Mail, Xmail, Files };

extern char logStart[ 16 ],
	    logEnd[ sizeof(logStart) ];

extern long logLines,
	    skipLines;

enum prsState
{
  noAction = 0,
  Answering, Dialing,
  Incoming, Outcoming,
  Executing, receivedMail,
  eventExit,
  BBS, BBS1,
  skipLine,
  terminalCalled,
  oldTMAnswer,
  FAXcall,
  eventsMap
};

extern char line[256], tag;
extern char getSkip;
extern big stamp, actionStarted;

extern prsState state;

// Hystory file

#define hystHeaderSign "\04\xfa This is VAGABONDO 1.1 history file \xfa\04"

struct HystHeader
{
  char sign[ sizeof(hystHeaderSign)-1 ];
  big date;
  big init;
  big lines;
  big size;
  big inSessions, outSessions,
      inHand, outHand,
      totalDialing, totalAnswering,
      totalIncome, totalOutcome,
      totalExternal,
      totalBBS,
      totalTerminal,
      totalBytesIn, totalBytesOut,
      inMail, inXmail, inFiles,
      outMail, outXmail, outFiles,
      sesFTS0001, sesWaZOO, sesEMSI, sesXZ;
char hLogStart[ sizeof(logStart) ],
     hLogEnd[ sizeof(logStart) ];
  unsigned short crc;
};

extern HystHeader hystHeader;

extern InfoStr hystInfo[48];
extern NodeInfo **hystNodes;
extern index hystTotalNodes;
extern IOInfo **hystIoInfo;
extern index hystTotalIO;

extern char useHysto,
            useTraff,
            useSess,
            debugMode;

extern char *logName,
            *statName,
            *hystName;

extern FILE *logFile,
            *statFile,
            *hystFile;

extern big fileSize;
extern int oldPercent;
extern char needProgressBar;
extern char newTMail;
extern char dumpBrakeBlg;

extern char *monthName[12];

// Origin

extern char *myAddress,
            *originName;
extern FILE *originFile,
            *originIdx;

struct OriginIDXHdr
{
  big time, len;
  int items;
};

typedef big OriginPtr;

extern OriginIDXHdr originIDXHdr;
extern OriginPtr *originPtr;

extern char *progName,
            *progVersion;

// MSG

extern char *fromName,
	    *toName,
	    *subjField,
	    *msgBase,
	    *toAddr;

// End declaration

inline int number( char *p )
{
  return (p[0] - '0')*10 + (p[1] - '0');
}

void checkPtr( void *addr );

int begin( char *orig, char *patt );
int end( char *orig, char *patt );

int getMonth( char *p );
const char * const suff( int n );

int checkAddress( char *addr, unsigned short& zone, unsigned short& net,
		   unsigned short& node, unsigned short& point,
		   char **domain, char flag=1 );

big registerTime( big time, prsState state );
void registerIO( char *protocol );

void binkParser();
void tmParser();
void brakeParser();

void stripLine( char *l );

void loadHystory( char *hystoryName );
void storeHystory();
void updateHystory();
void updateCounters();

void dumpStat( LOGStyle curLog );

int Cdecl addrCmp( const void *i1, const void *i2 );
int Cdecl ioCmp( const void *i1, const void *i2 );
int Cdecl io1Cmp( const void *i1, const void *i2 );

char *strTime( big elapsed );
char *strBig( double dsize );

void progressBar();

void compileOrigin();
void putOrigin();

void makeMsg( char *path, FILE *file,
	      char *from, char *to, char *sub,
	      char *addr, char *toAddr );
void makeJam( char *path, FILE *file,
	      char *from, char *to, char *sub,
	      char *addr, char *toAddr );

void capitalize( char *str );
int doMerge( int argn, char **argc );

enum StorageType { FileMsg=0, FidoMsg=1, JAMMsg=2 };

extern StorageType storageType;

// source trace

extern char *currentContext;
void printLine();
void printLine( const char * );
void IOerror( char * );

void returnToDos( int );

// chars

extern char extChar,
	    conChar,
	    sesChar,
	    bbsChar,
	    trmChar;

#define PAIR( x, y ) ( (((int)(y))<<8)|(x) )
